/**
 * Created by zjw-pc on 2016/6/4.
 */
(function () {
  angular.module("myApp")
    .controller("forgotPasswordController", forgotPasswordController);

  function forgotPasswordController($ionicHistory,$location, $cordovaToast, loadingService, accountService, _customerType) {
      var findPassword = this;
      findPassword.fnGoBack = fnGoBack;//返回方法
      findPassword.fnTelFindPassword = fnTelFindPassword;//忘记密码方法
      findPassword.fnTelUpdatePasswordSet = fnTelUpdatePasswordSet;//修改密码方法
      findPassword.IsTelephone = IsTelephone;//正则判断电话号
      //返回
      function fnGoBack() {
          $ionicHistory.goBack();
      }

      /**
       * 忘记密码输入手机号
       */
      function fnTelFindPassword() {
          var Tel = findPassword.Tel;
          //判断是否为空
          if (Tel == undefined) {
              $cordovaToast.showShortBottom('电话不能为空！');
              return;
          }
          //判断电话格式
          if (!findPassword.IsTelephone(Tel)) {
              $cordovaToast.showShortBottom('电话格式不正确！');
              return;
          }
          _customerType = findPassword.customerType ? 1 : 0;
          accountService.FunTelFindPassword(Tel)
              .then(function (data) {
                      if (data == "Tel") {
                          $cordovaToast.showShortBottom('没有找到电话！');
                          return;
                      }
                      if (data == "Sendfail") {
                          $cordovaToast.showShortBottom('发送失败！');
                          return;
                      }
                      if (data == "SendSuccess") {
                          $cordovaToast.showShortBottom('发送成功！');
                          return;
                      }
                      if (data == "SendTime") {
                          $cordovaToast.showShortBottom('发送时间还没有过期！');
                          return;
                      }
                  }, function (error) {
                      $cordovaToast.showShortBottom('网络出现异常！');
                  }
              );
      }


      /**
       * 修改密码
       */
      function fnTelUpdatePasswordSet() {
          var code = findPassword.Code;
          var password = findPassword.Password;
          //判断是否为空
          if (findPassword.Tel == undefined || code == undefined || password == undefined) {
              $cordovaToast.showShortBottom('输入信息不能为空！');
              return;
          }

          _customerType = findPassword.customerType ? 1 : 0;
          accountService.FunTelUpdatePasswordSet(findPassword.Tel, code, password)
              .then(function (data) {
                      if (data == "Not") {
                          $cordovaToast.showShortBottom('没有找到！');
                          return;
                      }
                      if (data == "Success") {
                          $cordovaToast.showShortBottom('修改成功！');
                          $state.go('login');
                          return;
                      }
                      if (data == "fail") {
                          $cordovaToast.showShortBottom('修改失败！');
                          return;
                      }
                  }, function (error) {
                      $cordovaToast.showShortBottom('网络出现异常！');
                  }
              );
      }


      /**
       * 电话号码正则判断
       */
      function IsTelephone(obj) {
          var pattern = /^1[34578]\d{9}$/;
          if (pattern.test(obj)) {
              return true;
          }
          else {
              return false;
          }
      }

  }
})()
