/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myBillController", myBillController);

  function myBillController(shopService, $ionicPopup, $stateParams, $cordovaToast, loadingService, myBillService, accountService) {
    var myBill = this;
    myBill.fnCreatePOSetGetItems = fnCreatePOSetGetItems;//定义方法
    myBill.fnCreatePOSetGet = fnCreatePOSetGet;//定义多个订单方法
    myBill.ProductId = $stateParams.productId;//接收产品id
    myBill.ids = $stateParams.ids;//接收产品id
    myBill.createPOSetGetItemsList = [];//创建新的数组用来接收数据
    myBill.createPoINfoList = [];//创建新的数组用来接收数据并展示
    myBill.customerID = accountService.fnGetUser().CustomerID;//获取customerID
    myBill.amount = 0;//价格
    myBill.isShowAmount = false;//控制是否显示原价

    /**
     * 请求产品订单
     */
    function fnCreatePOSetGetItems() {
      loadingService.show();
      myBillService.fnCreatePOSetGetItems_List(myBill.customerID, myBill.ProductId)
        .then(function (data) {
          //console.log("------------------->" + data);
          var datals = data[0];
          //if (data.FinalAmount > 0) {
          //  myBill.amount = data.FinalAmount;
          //  myBill.isShowAmount = true;//显示原价
          //} else {
          //  myBill.amount = data.UnitAmount;
          //}
          for (var i = 0; i < datals.length; i++) {

            if (!fnBoolean_PONoInList(datals[i].PONo, myBill.createPOSetGetItemsList)) {
              var item = {
                "PONo": datals[i].PONo,
                "POID": datals[i].POID,
                "Sum": 0
              };
              myBill.createPOSetGetItemsList.push(item);
            }
          }

          for (var i = 0; i < myBill.createPOSetGetItemsList.length; i++) {
            var PoInfo = fnLoadPoInfo(myBill.createPOSetGetItemsList[i].PONo, datals);
            myBill.createPoINfoList.push(PoInfo);
          }

          for (var i = 0; i < myBill.createPOSetGetItemsList.length; i++) {
            var num = 0;
            for (var j = 0; j < myBill.createPoINfoList[i].length; j++) {
              num += parseFloat(myBill.createPoINfoList[i][j].Price)
            }
            myBill.createPOSetGetItemsList[i].Sum = num.toFixed(2);
          }


          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     * 请求产品订单购物车处传递 多个订单
     */
    function fnCreatePOSetGet() {

      loadingService.show();
      myBillService.CarToPO(myBill.customerID, myBill.ProductId)
        .then(function (data) {
          if (data) {
            var list = [];
            shopService.fnSetShopCart(list);
          } else {
            $cordovaToast.showShortBottom('订单异常！');
          }
          loadingService.hide();
          //console.log("------------------->" + data);
          var datals = data[0];

          for (var i = 0; i < datals.length; i++) {

            if (!fnBoolean_PONoInList(datals[i].PONo, myBill.createPOSetGetItemsList)) {
              var item = {
                "PONo": datals[i].PONo,
                "POID": datals[i].POID,
                "Sum": 0
              };
              myBill.createPOSetGetItemsList.push(item);
            }
          }

          for (var i = 0; i < myBill.createPOSetGetItemsList.length; i++) {
            var PoInfo = fnLoadPoInfo(myBill.createPOSetGetItemsList[i].PONo, datals);
            myBill.createPoINfoList.push(PoInfo);
          }

          for (var i = 0; i < myBill.createPOSetGetItemsList.length; i++) {
            var num = 0;
            for (var j = 0; j < myBill.createPoINfoList[i].length; j++) {
              num += parseFloat(myBill.createPoINfoList[i][j].Price)
            }
            myBill.createPOSetGetItemsList[i].Sum = num.toFixed(2);
          }


          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     * 查重
     * @param PONo
     * @param POListGetList
     * @returns {boolean}
     */
    function fnBoolean_PONoInList(PONo, POListGetList) {
      for (var i = 0; i < POListGetList.length; i++) {
        if (POListGetList[i].PONo == PONo) {
          return true;
        }
      }
      return false;
    };

    function fnLoadPoInfo(PONo, datalst) {
      var PoInfoList = new Array();
      for (var i = 0; i < datalst.length; i++) {
        if (datalst[i].PONo == PONo) {
          var item = {
            "PONo": datalst[i].PONo,
            "POID": datalst[i].POID,
            "CourseName": datalst[i].ProductName,
            "Price": datalst[i].FinalAmount
          };
          PoInfoList.push(item);
        }
      }
      return PoInfoList;
    };

    if (myBill.ids == 0) {
      //启动单个订单方法
      fnCreatePOSetGetItems()
    } else {
      //启动购物车多个个订单方法
      fnCreatePOSetGet()
    }


  }
})()
