/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("myBillListController", myBillListController);

    function myBillListController($state, $scope, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, myBillService, accountService) {
        var myBillList = this;
        myBillList.fnPO_ListGet = fnPO_ListGet;//定义列表方法
        myBillList.funPO_Del = funPO_Del;//定义删除方法
        myBillList.loadNewerStories = loadNewerStories;//定义刷新方法
        myBillList.fnGoList = fnGoList;
        myBillList.fnBoolean_PONoInList = fnBoolean_PONoInList;
        myBillList.fnLoadPoInfo = fnLoadPoInfo;
        myBillList.ProductId = $stateParams.productId;//接收产品id
        myBillList.createPOListGetList = [];//创建新的数组用来接收数据
        myBillList.createPoINfoList = [];//创建新的数组用来接收数据并展示
        myBillList.customerID = accountService.fnGetUser().CustomerID;//获取customerID
        function fnGoList() {
            $state.go('tab.person');
            //$location.path("tab/person");
        }

        function loadNewerStories() {
            myBillList.createPOListGetList = [];
            myBillList.createPoINfoList = [];//2017/6/1 订单刷新
            fnPO_ListGet();
            //window.location.reload();
            $scope.$broadcast('scroll.refreshComplete');//广播结束
        }

        /**
         * 请求产品订单列表
         */
        function fnPO_ListGet() {
            loadingService.show();
            myBillService.FunPO_ListGet(myBillList.customerID, 20, 1)
                .then(function (data) {
                    //console.log("------------------->" + data);
                    var datals = data[0];
                    if (data[0].length <= 0) {
                        var alertPopup = $ionicPopup.alert({
                            title: '提示',
                            template: '暂无订单！'
                        });
                        alertPopup.then(function (res) {
                            $location.path("/tab/person");
                        });
                        loadingService.hide();
                        return;
                    }


                    for (var i = 0; i < datals.length; i++) {
                        if (!fnBoolean_PONoInList(datals[i].PONo, myBillList.createPOListGetList)) {
                            var item = {
                                "PONo": datals[i].PONo,
                                "POID": datals[i].POID,
                                "Sum": 0
                            };
                            myBillList.createPOListGetList.push(item);
                        }
                    }
                    for (var i = 0; i < myBillList.createPOListGetList.length; i++) {
                        var PoInfo = fnLoadPoInfo(myBillList.createPOListGetList[i].PONo, datals);
                        myBillList.createPoINfoList.push(PoInfo);
                    }

                    for (var i = 0; i < myBillList.createPOListGetList.length; i++) {
                        var num = 0;
                        for (var j = 0; j < myBillList.createPoINfoList[i].length; j++) {
                            num += parseFloat(myBillList.createPoINfoList[i][j].Price);//2017/8/18 保留两位小数
                        }
                        myBillList.createPOListGetList[i].Sum = num.toFixed(2);
                    }

                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        /**
         * 删除订单
         */
        function funPO_Del(POID) {
            loadingService.show();
            myBillService.funPO_Del(POID)
                .then(function (data) {
                    //console.log("------------------->" + data);
                    if (data == "") {
                        myBillList.createPOListGetList = [];
                        myBillList.createPoINfoList = [];
                        fnPO_ListGet();
                        //window.location.reload();
                        $cordovaToast.showShortBottom('取消成功！');
                    }
                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        //启动方法
        fnPO_ListGet()

        /**
         * 查重
         * @param PONo
         * @param POListGetList
         * @returns {boolean}
         */
        function fnBoolean_PONoInList(PONo, POListGetList) {
            for (var i = 0; i < POListGetList.length; i++) {
                if (POListGetList[i].PONo == PONo) {
                    return true;
                }
            }
            return false;
        };

        function fnLoadPoInfo(PONo, datalst) {
            var PoInfoList = new Array();
            for (var i = 0; i < datalst.length; i++) {
                if (datalst[i].PONo == PONo) {
                    var item = {
                        "PONo": datalst[i].PONo,
                        "POID": datalst[i].POID,
                        "CourseName": datalst[i].CourseName,
                        "Price": datalst[i].Price
                    };
                    PoInfoList.push(item);
                }
            }
            return PoInfoList;
        };

    }
})()
