/**
 * Created by trueideal on 2016/6/4.
 */
(function () {
  angular.module("myApp")
    .controller("myBillPayController", myBillPayController);

  function myBillPayController($location, accountService, $interval, $ionicPopup, $stateParams, $cordovaToast, loadingService, myBillPayService) {
    var myBillPayItem = this;
    var objtimer = null;
    myBillPayItem.curr = 0;
    myBillPayItem.poNo = $stateParams.poNo;
    myBillPayItem.fnAlipayPay = fnAlipayPay;
    myBillPayItem.fnWeChatPay = fnWeChatPay;
    myBillPayItem.cb_success = cb_success;//微信成功
    myBillPayItem.cb_failure = cb_failure;//微信失败
    myBillPayItem.fn_success = fn_success;//支付宝成功
    myBillPayItem.fn_failure = fn_failure;//支付宝失败
    myBillPayItem.fnLoadPayItemInfo = fnLoadPayItemInfo;
    //myBillPayItem.currAdd = currAdd;
    myBillPayItem.PoInfo = {};


    myBillPayItem.fnGoList = fnGoList;
    function fnGoList() {
      $location.path("my/billList");
    }

    myBillPayItem.fnBalancePay = fnBalancePay;//余额支付
    //余额支付方法  2017/10/20
    function fnBalancePay(payType) {
      myBillPayService.fnPay(payType, myBillPayItem.poNo)
        .then(function (data) {
          if (data == "Balance") {
            $cordovaToast.showShortBottom('余额不足！');
          } else if (data == "Not") {
            $cordovaToast.showShortBottom('未找到订单！');
          } else {
            var list = accountService.fnGetUser();
            list.Amount = list.Amount - myBillPayItem.PoInfo;
            list.Amount = parseFloat(list.Amount).toFixed(2);
            if (list.Amount < 0) {//增加小于0后等于0 2017/10/24
              list.Amount = 0;
            }
            accountService.fnSetUser(list);
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '余额支付成功！'
            });
            alertPopup.then(function (res) {
              $location.path("/tab/person");
            });
            $cordovaToast.showShortBottom('支付成功！');
          }
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     * 请求详细信息
     */
    function fnLoadPayItemInfo() {
      loadingService.show();
      myBillPayService.fnLoadPayItemInfo(myBillPayItem.poNo)
        .then(function (data) {
          myBillPayItem.PoInfo = data;
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     * 支付宝支付
     * @param payType 支付类型
     */
    function fnAlipayPay(payType) {
      //loadingService.show();
      //myBillPayService.fnPay(payType, myBillPayItem.poNo)
      //  .then(function (data) {
      //    if (data == "Not") {
      //      $cordovaToast.showShortBottom('订单已提交或不存在！');
      //    } else {
      //      objtimer = $interval(myBillPayItem.currAdd, 1000);
      //    }
      //    document.getElementById("divform").innerHTML = data;
      //    document.getElementById("alipaysubmit").submit();
      //    loadingService.hide();
      //  }, function (error) {
      //    $cordovaToast.showShortBottom('网络出现异常！');
      //  });

      myBillPayService.fnPay(payType, myBillPayItem.poNo)
        .then(function (data) {
          //alert(data)
          //var d="partner=\"2088501583485177\"&seller_id=\"2088501583485177\"&out_trade_no=\"9009999181881818\"&subject=\"test\"&body=\"test001\"&total_fee=\"0.01\"&notify_url=\"http://101.200.0.3:10001/Phone.PayReturn/WebAlipay/notify_url.aspx\"&service=\"mobile.securitypay.pay\"&payment_type=\"1\"&_input_charset=\"utf-8\"&it_b_pay=\"30m\"&return_url=\"m.alipay.com\"&sign=\"PEFkSzijYIrFLJfTfq1k6S5MacaBvRKT0jUMPFx3sUjMN5gbePu0FxYQzHEeHxvTp7N%2b%2b0QKDyGy2GmFYy8LrkETRHLy%2bIIdw9TwKN5zOPpyaQo3DTb1on5M7DRz45gp1d36e9k8lEzmP7t9PfyEzo8qAXX6pU6gJxFKeUR6xug%3d\"&sign_type=\"RSA\"";
          //alert(d);
          //var json = {
          //  "pay_info":d,
          //  "sign": "OR4Va5VU2SgByvpbJh3eEjb1yepzp+AtgdXACjjSTCKynHMngFuXZQYUXh/ulz+uNWgMoNE/s8MwFu1RPxugKQFnxIg8HsHrengcOtEW3Acy8y7FZp1/Gs920Ing+cy+OJjqZxqCyUTj9PA/GTbL/FvnzXUl2zi9pwdX1dqJ1Vo=&sign_type=RSA"
          //}
          var json = {
            "pay_info": data,
            "sign": "OR4Va5VU2SgByvpbJh3eEjb1yepzp+AtgdXACjjSTCKynHMngFuXZQYUXh/ulz+uNWgMoNE/s8MwFu1RPxugKQFnxIg8HsHrengcOtEW3Acy8y7FZp1/Gs920Ing+cy+OJjqZxqCyUTj9PA/GTbL/FvnzXUl2zi9pwdX1dqJ1Vo=&sign_type=RSA"
          };
          alipay.payment(json, fn_success, fn_failure);

          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     * 支付宝支付成功
     * @param mes
     */
    function fn_success(mes) {
      //alert(mes + "成功");
      var json = JSON.parse(mes);
      //alert(json.memo);
      if (json.resultStatus == 6001) {
        var alertPopup = $ionicPopup.alert({
          title: '提示',
          template: json.memo + ""
        });
      } else if (json.resultStatus == 9000) {
        myBillPayService.FunPOPayReturn(myBillPayItem.poNo, "Alipay")
          .then(function (data) {
            //alert("进入FunPOPayReturn方法data="+data)
            if (data == "Complete ") {
              $cordovaToast.showShortBottom('订单已已完成！');
            } else if (data == "Amount") {
              $cordovaToast.showShortBottom('订单金额错误！');
            } else if (data == "Not") {
              $cordovaToast.showShortBottom('订单不存在！');
            } else if (data == "error") {
              $cordovaToast.showShortBottom('系统错误！');
            } else if (data == "") {
              $cordovaToast.showShortBottom('成功！');
            }

            //alert(data)
          });
        var alertPopup = $ionicPopup.alert({
          title: '提示',
          template: '支付宝支付成功！'
        });
        alertPopup.then(function (res) {
          $location.path("/tab/person");
        });
      }
    }

    /**
     * 支付宝支付失败
     * @param mes
     */
    function fn_failure(mes) {
      //alert(mes+"失败");
      //var json = JSON.parse(mes);
      //alert(json);
      //var alertPopup = $ionicPopup.alert({
      //  title: '提示',
      //  template: json.memo + ""
      //});
    }


    /**
     * 微信支付
     * @param payType 支付类型
     */
    function fnWeChatPay(payType) {
      loadingService.show();
      myBillPayService.fnPay(payType, myBillPayItem.poNo)
        .then(function (data) {
          if (data == "Not") {
            $cordovaToast.showShortBottom('订单已提交或不存在！');
          }
          //var json =
          //{
          //  "appid": data.appid,
          //  "noncestr": data.noncestr,
          //  "package": "Sign=WXPay",
          //  "prepayid": data.prepayid,
          //  "partnerid": data.partnerid,
          //  "timestamp": data.timestamp,
          //  "sign": data.sign
          //};
          //wxpay.payment(json, cb_success, cb_failure);//微信调用 旧插件弃用2017/11/20
          var params =
          {
            "partnerid": data.partnerid,
            "prepayid": data.prepayid,
            "noncestr": data.noncestr,
            "timestamp": data.timestamp,
            "sign": data.sign
          };

          Wechat.sendPaymentRequest(params, cb_success, cb_failure);//微信调用 2017/11/20
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //微信成功
    function cb_success(mes) {
      //alert(mes);
      //var json = JSON.parse(mes);
      myBillPayService.FunPOPayReturn(myBillPayItem.poNo, "WeChat")
        .then(function (data) {
          if (data == "Complete ") {
            $cordovaToast.showShortBottom('订单已已完成！');
          } else if (data == "Amount") {
            $cordovaToast.showShortBottom('订单金额错误！');
          } else if (data == "Not") {
            $cordovaToast.showShortBottom('订单不存在！');
          } else if (data == "error") {
            $cordovaToast.showShortBottom('系统错误！');
          } else if (data == "") {
            $cordovaToast.showShortBottom('成功！');
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '微信支付成功！'
            });
            alertPopup.then(function (res) {
              $location.path("/tab/person");
            });
          }
        });


    }

    //微信失败
    function cb_failure(mes) {
      var alertPopup = $ionicPopup.alert({
        title: '提示',
        template: mes
      });
    }

    //alert("Failed: " + mes);
    //alert(mes);
    //var json = JSON.parse(mes);
    //alert(json);
    //  if (json.code == -1) {
    //    var alertPopup = $ionicPopup.alert({
    //      title: '提示',
    //      template: '微信支付失败！'
    //    });
    //  } else if (json.code == -2) {
    //    var alertPopup = $ionicPopup.alert({
    //      title: '提示',
    //      template: '取消支付！'
    //    });
    //  }
    //}

    //
    //function currAdd() {
    //  if (myBillPayItem.curr >= 5) {
    //    myBillPayService.fnCPOPayStateGet(myBillPayItem.poNo)
    //      .then(function (data) {
    //        if (data == "success") {
    //          var pop = $ionicPopup.alert({
    //            title: '提示',
    //            template: "订单支付成功！"
    //          }).then(function (res) {
    //            $interval.cancel(objtimer);
    //            $location.path("tab/person");
    //          });
    //        }
    //        else {
    //          myBillPayItem.curr = 0;
    //          objtimer = $interval(myBillPayItem.currAdd, 1000);
    //        }
    //        loadingService.hide();
    //      }, function (error) {
    //        $cordovaToast.showShortBottom('网络出现异常！');
    //      });
    //    $interval.cancel(objtimer);
    //    return;
    //  }
    //  myBillPayItem.curr++;
    //}

    fnLoadPayItemInfo();
  }
})();
