/**
 * Created by zjw-pc on 2016/5/21.
 * 合同详情
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myContractListController", myContractListController);

  function myContractListController($ionicHistory, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, myContractService) {
    var courseInfoList = this;
    courseInfoList.fnContractInfotGet = fnContractInfotGet;//定义方法
    courseInfoList.fnGoList = fnGoList;//定义方法
    courseInfoList.CourseName = $stateParams.CourseName;
    courseInfoList.CourseInfoListLists = new Array();//创建新的数组用来接收数据并展示
    courseInfoList.ContractID = $stateParams.ContractID;//获取ContractID
    courseInfoList.formatSeconds = formatSeconds;//秒换算小时
    courseInfoList.fnCourseType = fnCourseType;//课程状态
    function fnGoList() {
      $ionicHistory.goBack();
      //$location.path("my/contractList");
    }

    /**
     * 自动加时 2017/6/6
     * @type {fnSetOverTimeSave}
     */
    courseInfoList.fnSetOverTimeSave = fnSetOverTimeSave;
    function fnSetOverTimeSave(ContractID) {
      loadingService.show();
      myContractService.FunSetOverTimeSave(ContractID)
        .then(function (data) {
          if (data == "Time") {
            $cordovaToast.showShortBottom('时间大于10小时！');
          } else if (data == "error") {
            $cordovaToast.showShortBottom('系统错误！');
          } else {
            $cordovaToast.showShortBottom('加时成功！');
          }
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     * 请求我的合同详细信息
     */
    function fnContractInfotGet() {
      loadingService.show();
      myContractService.FunContractInfotGet(courseInfoList.ContractID)
        .then(function (data) {
          var item = {
            "Termination": data.Termination,//是否终止
            "TerminationRemark": isNull(data.TerminationRemark),//终止原因 2017/9/18
            "VideoTimes": courseInfoList.formatSeconds(data.VideoTimes),//视频学习时间 2017/9/18
            "isFreezed": data.isFreezed,//是否冻结
            "RLearnCount": data.RLearnCount,//重学次数
            "isClosed": data.isClosed,//是否关闭
            "courseType": courseInfoList.fnCourseType(data.isFreezed, data.isClosed),//课程状态终止
            "ExaminationTime": data.ExaminationTime,//期考试时间
            "CreatedDate": data.CreatedDate,//创购买日期
            "ExaminationTimeName": data.ExaminationTimeName,//期考试时间
            "ContractDays": data.ContractDays,
            "Completion": data.Completion,
            "CourseName": data.CourseName,
            "StandardTime": data.StandardTime,//总共时间
            "RemainderTime": courseInfoList.formatSeconds(data.RemainderTime),//剩余时间
            "ContractID": courseInfoList.ContractID,
            "ContractContentID": data.ContractContentID,
            "ExaminationTimeID": data.ExaminationTimeID,//期数id 2017/6/6
            "ProductID": data.ProductID,//产品id 2017/6/6
            "CourseID": data.CourseID//课程id 2017/6/6
          };
          courseInfoList.CourseInfoListLists.push(item);
          if (data.Termination) {
            courseInfoList.CourseInfoListLists[0].Termination = "终止"
          } else {
            courseInfoList.CourseInfoListLists[0].Termination = "未终止"
          }
          if (data.ExaminationTimeName == null) {
            courseInfoList.CourseInfoListLists[0].ExaminationTimeName = "未设置"
          }
          if (data.ExaminationTime == null) {
            courseInfoList.CourseInfoListLists[0].ExaminationTime = "未设置"
          }

          courseInfoList.isShowBottomTab = data.IsOtherProduct; // 其他的产品 为true时隐藏 2017/12/17
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //是否为空 2017/9/18
    function isNull(age) {
      if (age == null) {
        return "未终止";
      } else {
        return age;
      }
    }

    //启动方法
    fnContractInfotGet()

    function fnCourseType(isFreezed, isClosed) {
      var arrCourseType = [];
      if (isFreezed && isClosed) {//已冻结，已关闭
        var item = {
          "freezedType": "已冻结",
          "closedType": "已关闭",
          "freezedColor": "#c2c2c2",
          "closedColor": "#c2c2c2"
        }
        arrCourseType.push(item);
        return arrCourseType;
      }
      else if (!isFreezed && isClosed) {//未冻结，已关闭
        var item = {
          "freezedType": "未冻结",
          "closedType": "已关闭",
          "freezedColor": "#0a9ec7",
          "closedColor": "#c2c2c2"
        }
        arrCourseType.push(item);
        return arrCourseType;
      }
      else if (!isFreezed && !isClosed) {//未冻结，未关闭
        var item = {
          "freezedType": "未冻结",
          "closedType": "未关闭",
          "freezedColor": "#0a9ec7",
          "closedColor": "#0a9ec7"
        }
        arrCourseType.push(item);
        return arrCourseType;
      }
      else if (isFreezed && !isClosed) {//已冻结，未关闭
        var item = {
          "freezedType": "已冻结",
          "closedType": "未关闭",
          "freezedColor": "#c2c2c2",
          "closedColor": "#0a9ec7"
        }
        arrCourseType.push(item);
        return arrCourseType;
      }
    }

    /**
     * 秒换算小时
     * @param msd
     * @returns {number}
     * @constructor
     */
    function formatSeconds(msd) {
      var theTime = parseInt(msd);// 秒
      if (theTime <= 0) {//2017/6/21  时间小于0  就等于0
        theTime = 0;
      }
      var theTime1 = 0;// 分
      var theTime2 = 0;// 小时
      if (theTime > 60) {
        theTime1 = parseInt(theTime / 60);
        theTime = parseInt(theTime % 60);
        if (theTime1 > 60) {
          theTime2 = parseInt(theTime1 / 60);
          theTime1 = parseInt(theTime1 % 60);
        }
      }
      var result = "" + parseInt(theTime) + "秒";
      if (theTime1 > 0) {
        result = "" + parseInt(theTime1) + "分" + result;
      }
      if (theTime2 > 0) {
        result = "" + parseInt(theTime2) + "小时" + result;
      }
      return result;
    }

  }
})()
