/**
 * Created by zjw-pc
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myContractRelearningController", myContractRelearningController);

  function myContractRelearningController($ionicPopup, accountService, $stateParams, $cordovaToast, loadingService, myContractService) {
    var contractRelearning = this;
    contractRelearning.fnSetRLearnSave = fnSetRLearnSave;//定义方法
    contractRelearning.fnGetRLearnExaminationList = fnGetRLearnExaminationList;//定义方法
    contractRelearning.ContractContentLists = [];//创建新的数组用来接收数据并展示
    contractRelearning.ContractID = $stateParams.ContractID;
    contractRelearning.ExaminationTimeID = $stateParams.ExaminationTimeID;
    contractRelearning.ProductID = $stateParams.ProductID;
    contractRelearning.CourseID = $stateParams.CourseID;
    contractRelearning.CustomerID = accountService.fnGetUser().CustomerID;
    contractRelearning.ExaminationList = [];//重学期数列表数组

    /**
     * 请求我的合同保存重学申请
     */
    function fnSetRLearnSave() {
      var InstituteLoginName = contractRelearning.InstituteLoginName;
      var InstituteLoginPassword = contractRelearning.InstituteLoginPassword;
      if (InstituteLoginName == undefined || InstituteLoginPassword == undefined) {
        $cordovaToast.showShortBottom('协会账号和密码不能为空！');
        return;
      }
      var Reason = contractRelearning.Reason;
      var Remark = contractRelearning.Remark;
      if (Reason == undefined) {
        Reason = "";
      }
      if (Remark == undefined) {
        Remark = "";
      }
      var ExaminationTimeID = "";
      for (var i = 0; i < contractRelearning.ExaminationList.length; i++) {//判断是否选择的InstituteLoginName 获取期数ID
        if (contractRelearning.ExaminationTimeName == contractRelearning.ExaminationList[i].ExaminationTimeName) {
          ExaminationTimeID = contractRelearning.ExaminationList[i].ExaminationTimeID;
        }
      }
      loadingService.show();
      myContractService.FunSetRLearnSave(InstituteLoginName, InstituteLoginPassword, Reason, Remark, contractRelearning.ContractID, ExaminationTimeID, contractRelearning.CustomerID)
        .then(function (data) {
          loadingService.hide();
          if (data == "NotContract") {
            $cordovaToast.showShortBottom('没有找到合同！');
          } else if (data == "Termination") {
            $cordovaToast.showShortBottom('合同已终止！');
          }
          else if (data == "Submitted") {
            $cordovaToast.showShortBottom('等待审核！');
          }
          else if (data == "NowExaminationTime") {
            $cordovaToast.showShortBottom('没有找到当前选择期数！');
          }
          else if (data == "NotClosed") {
            $cordovaToast.showShortBottom('合同未关闭！');
          }
          else if (data == "CurrentExamination") {
            $cordovaToast.showShortBottom('没有找到已经选择的期数！');
          }else {
            $cordovaToast.showShortBottom('提交成功！');
          }
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    fnGetRLearnExaminationList();
    /**
     * 重学期数列表
     */

    function fnGetRLearnExaminationList() {
      loadingService.show();
      myContractService.FunGetRLearnExaminationList(contractRelearning.ProductID, contractRelearning.CourseID)
        .then(function (data) {
          contractRelearning.ExaminationList = data[0];
          contractRelearning.ExaminationTimeName = contractRelearning.ExaminationList[0].ExaminationTimeName;//select默认给第一个
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

  }
})()
