/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myContractSettingController", myContractSettingController);

  function myContractSettingController($ionicHistory,$ionicPopup, $location, $stateParams, $cordovaToast, loadingService, myContractService) {
    var contractSetting = this;
    contractSetting.fnExaminationTimeListGet = fnExaminationTimeListGet;//定义我的期数列表方法
    contractSetting.fnExaminationTimeSaveSet = fnExaminationTimeSaveSet;//定义保存期数方法
    contractSetting.CourseInfoSettingLists = [];//创建新的数组用来接收数据并展示
    contractSetting.ContractID = $stateParams.ContractID;//获取ContractID
    /**
     * 请求我的期数列表
     */
    function fnExaminationTimeListGet() {
      loadingService.show();
      myContractService.FunExaminationTimeListGet(contractSetting.ContractID)
        .then(function (data) {
          if (data == "not") {
            loadingService.hide();
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '没有找到合同！'
            });
            alertPopup.then(function (res) {
              $ionicHistory.goBack();
            });
          }

          for (var i = 0; i < data[0].length; i++) {
            var item = {
              "ExaminationTimeID": data[0][i].ExaminationTimeID,
              "ExaminationTimeName": data[0][i].ExaminationTimeName,
              "CourseID": data[0][i].CourseID,
              "CourseName": data[0][i].CourseName,
              "isCloss": data[0][i].isCloss,
              "MyExaminationTimeID": data[0][i].MyExaminationTimeID,
              "Time": data[0][i].Time,
              "colorItem": "#dddddd"
            }

            contractSetting.CourseInfoSettingLists.push(item);
          }
          for (var j = 0; j < contractSetting.CourseInfoSettingLists.length; j++) {
            if (contractSetting.CourseInfoSettingLists[j].MyExaminationTimeID != null && contractSetting.CourseInfoSettingLists[j].MyExaminationTimeID != undefined && contractSetting.CourseInfoSettingLists[j].MyExaminationTimeID != "") {
              contractSetting.CourseInfoSettingLists[j].colorItem = "#27c0d2"
            }
          }

          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //启动方法
    fnExaminationTimeListGet()
    /**
     * 保存期数
     */
    function fnExaminationTimeSaveSet(ExaminationTimeID) {
      loadingService.show();
      myContractService.FunExaminationTimeSaveSet(contractSetting.ContractID, ExaminationTimeID)
        .then(function (data) {
          if (data == "Choice") {
            loadingService.hide();
            $cordovaToast.showShortBottom('您已选择本期考试，不能更改！');
          }
          if (data == "BeOverdue") {
            loadingService.hide();
            $cordovaToast.showShortBottom('考试时间已过期！');
          }
          if (data == "notContract") {
            loadingService.hide();
            $cordovaToast.showShortBottom('没有找到合同！');
          }
          if (data == "notExamination") {
            loadingService.hide();
            $cordovaToast.showShortBottom('没有找到期数！');
          }
          if (data == "Success") {
            contractSetting.CourseInfoSettingLists = new Array();
            contractSetting.fnExaminationTimeListGet();
            loadingService.hide();
          }
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }
  }
})()
