/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("myModifyDataController", myModifyDataController);

    function myModifyDataController($state,$ionicPopup, $location, $cordovaToast, loadingService, accountService, _customerType) {
        var myModifyData = this;
        myModifyData.fnUserInfo = fnUserInfo;//修改方法
        myModifyData.customerType = false;
        myModifyData.IsTelephone = IsTelephone;//正则判断电话号
        myModifyData.CheckMail = CheckMail;//判断邮箱是否正确
        myModifyData.CustomerID = accountService.fnGetUser().CustomerID;
        myModifyData.RealName = accountService.fnGetUser().RealName;
        myModifyData.IdentityCard = accountService.fnGetUser().IdentityCard;
        myModifyData.QQ = accountService.fnGetUser().QQ;
        myModifyData.Tel = accountService.fnGetUser().Tel;
        myModifyData.Email = accountService.fnGetUser().Email;

        myModifyData.isDisable = false;//2017/6/1  不许修改身份证
        if (myModifyData.IdentityCard != "") {
            myModifyData.isDisable = true;
        }
        myModifyData.fnGoList=fnGoList;
        function fnGoList() {
            //$state.go('tab.person');
            $location.path("tab/person");
        }

        /**
         * 修改方法
         */
        function fnUserInfo() {
            var RealName = myModifyData.RealName;
            var IdentityCard = myModifyData.IdentityCard;
            var QQ = myModifyData.QQ;
            var Tel = myModifyData.Tel;
            var Email = myModifyData.Email;
            //判断是否为空
            if (RealName == "" || Email == "") {
                $cordovaToast.showShortBottom('姓名和邮箱不能为空！');
                return;
            }
            //判断电话格式
            if (!myModifyData.IsTelephone(Tel)) {
                $cordovaToast.showShortBottom('电话格式不正确！');
                return;
            }
            //判断邮箱格式
            if (!myModifyData.CheckMail(Email)) {
                $cordovaToast.showShortBottom('邮箱格式不正确！');
                return;
            }
            loadingService.show();
            accountService.FunUserInfoSet(RealName, IdentityCard, QQ, Tel, Email, myModifyData.CustomerID)
                .then(function (data) {
                    console.log(data)
                    if (data == "Tel") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('修改失败,电话存在！');
                        return;
                    }
                    if (data == "IdentityCard") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('修改失败,身份证存在！');
                        return;
                    }
                    if (data == "Email") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('修改失败,邮箱存在！');
                        return;
                    }
                    if (data == "fail") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('修改失败！');
                        return;
                    }
                    if (data == "Success") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('修改成功！');
                        return;
                    }

                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        /**
         * 电话号码正则判断
         * @param obj
         * @returns {boolean}
         * @constructor
         */
        function IsTelephone(obj) {
            var pattern = /^1[34578]\d{9}$/;
            if (pattern.test(obj)) {
                return true;
            }
            else {
                return false;
            }
        }

        /**
         * 判断邮箱是否正确
         * @param mail
         * @returns {boolean}
         * @constructor
         */
        function CheckMail(mail) {
            var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
            if (filter.test(mail)) {
                return true;
            }
            else {
                return false;
            }
        }

    }
})()
