/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
    'use strict';
    angular.module("myApp")
        .controller("userRegisterController", userRegisterController);

    function userRegisterController($ionicHistory, $interval, $ionicPopup, $location, $cordovaToast, loadingService, accountService, _customerType) {
        var userRegister = this;
        userRegister.fnRegister = fnRegister;//注册方法
        userRegister.customerType = false;
        userRegister.IsTelephone = IsTelephone;//正则判断电话号
        userRegister.fuGetRegisterCode = fuGetRegisterCode;//获取验证码
        var objtimer = null;//2017/5/25

        userRegister.btnStr = "获取验证码";//2017/5/25
        userRegister.isDisabked = false;//2017/5/25
        userRegister.fnGoBack = fnGoBack;//返回方法
        //返回
        function fnGoBack() {
            $ionicHistory.goBack();
        }

        /**
         * 获取验证码 2017/5/25
         */
        function fuGetRegisterCode() {
            if (userRegister.name == undefined) {
                $cordovaToast.showShortBottom('电话不能为空！');
                return;
            }
            //判断电话格式
            if (!userRegister.IsTelephone(userRegister.name)) {
                $cordovaToast.showShortBottom('电话格式不正确！');
                return;
            }
            accountService.FuGetRegisterCode(userRegister.name)
                .then(function (data) {
                    if (data == "Tel") {
                        $cordovaToast.showShortBottom('电话已存在！');
                    } else {
                        userRegister.times = 60;
                        userRegister.isDisabked = true;
                        var toDo = function () {
                            userRegister.times--;
                            if (userRegister.times <= 0) {
                                userRegister.isDisabked = false;
                                userRegister.btnStr = "获取验证码";
                                userRegister.times = "";
                                $interval.cancel(objtimer);
                            }
                        };
                        objtimer = $interval(toDo, 1000);
                        userRegister.btnStr = "s后再次获取";
                    }
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        /**
         * 注册
         */
        function fnRegister() {
            var name = userRegister.name;
            var password1 = userRegister.password1;
            var code = userRegister.code;
            //判断是否为空
            if (name == undefined || password1 == undefined) {
                $cordovaToast.showShortBottom('电话和密码不能为空！');
                return;
            }
            //判断电话格式
            if (!userRegister.IsTelephone(name)) {
                $cordovaToast.showShortBottom('电话格式不正确！');
                return;
            }
            loadingService.show();
            _customerType = userRegister.customerType ? 1 : 0;
            accountService.fnUserRegister(userRegister.name, password1, 0, code)
                .then(function (data) {
                        if (data == "Tel") {
                            loadingService.hide();
                            $cordovaToast.showShortBottom('注册失败,已注册！');
                            return;
                        } else if (data == "Code") {
                            loadingService.hide();
                            $cordovaToast.showShortBottom('注册失败,验证码错误！');
                        }
                        else if (data == "Register") {//2017/10/23  多加个返回值
                            loadingService.hide();
                            $cordovaToast.showShortBottom('注册失败,已注册！');
                        }
                        accountService.fnUserLogin(userRegister.name, userRegister.password1, 0)
                            .then(function (data) {
                                if (data.CustomerID == undefined) {
                                    loadingService.hide();
                                    $cordovaToast.showShortBottom('登录信息不正确！');
                                    return;
                                }
                                loadingService.hide();
                                $location.path("tab/person")
                            }, function (error) {
                                $cordovaToast.showShortBottom('网络出现异常！');
                            });
                    }, function (error) {
                        $cordovaToast.showShortBottom('网络出现异常！');
                    }
                );
        }

        /**
         * 电话号码正则判断
         */
        function IsTelephone(obj) {
            //var pattern = /^(?:13\d|15\d|17\d|18\d)\d{5}(\d{3}|\*{3})$/;
            var pattern = /^1[34578]\d{9}$/;
            if (pattern.test(obj)) {
                return true;
            }
            else {
                return false;
            }
        }

    }
})()
