/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("answeringQuestionController", answeringQuestionController);

    function answeringQuestionController($state, $ionicHistory, $ionicLoading, $cordovaToast, $ionicPopup, $location, $stateParams, loadingService, learingingBoardService, $interval, accountService) {
        var answeringQuestion = this;
        answeringQuestion.goBacks = goBacks;
        function goBacks() {
            $state.go('tab.person');
        }

        /**
         * 我的答疑题列表
         * @type {fnGetMyAnswering}
         */
        answeringQuestion.fnGetMyAnswering = fnGetMyAnswering;
        answeringQuestion.answeringQuestionList = [];
        function fnGetMyAnswering() {
            loadingService.show();
            learingingBoardService.fnGetMyAnsweringQuestionList(50, 1)
                .then(function (data) {
                    if (data[0].length <= 0) {
                        var alertPopup = $ionicPopup.alert({
                            title: '提示',
                            template: '暂无内容！'
                        });
                        alertPopup.then(function (res) {
                            $location.path("/tab/person");
                        });
                        loadingService.hide();
                        return;
                    }

                    for (var i = 0; i < data[0].length; i++) {
                        var item = {
                            "QuestionID": data[0][i].QuestionID,
                            "CreatedDate": data[0][i].CreatedDate,
                            "Topic": data[0][i].Topic,
                            "AnalyticDesc": data[0][i].AnalyticDesc,
                            "AnswersID": data[0][i].AnswersID,
                            "AnswersNos": "",
                            "questionList": [],
                            "answeringList": [],
                            "btnStr": "展开",
                            "isShow": false
                        };
                        answeringQuestion.answeringQuestionList.push(item);
                    }

                    //答疑加入解析  选项 正确答案 2017/10/13
                    for (var j in answeringQuestion.answeringQuestionList) {
                        var list = [];
                        var idx = 0;
                        for (var k in data[2]) {
                            if (answeringQuestion.answeringQuestionList[j].QuestionID == data[2][k].QuestionID) {
                                var ite = {
                                    ANo: String.fromCharCode(idx + 65),
                                    AnswersID: data[2][k].AnswerID,
                                    AnswerContent: data[2][k].AnswerContent
                                };
                                list.push(ite);
                                answeringQuestion.answeringQuestionList[j].answeringList = list;
                                idx++;
                            }
                        }
                    }
                    //筛选正确答案 2017/10/13
                    for (var f = 0; f < answeringQuestion.answeringQuestionList.length; f++) {
                        for (var l = 0; l < answeringQuestion.answeringQuestionList[f].answeringList.length; l++) {
                            if (answeringQuestion.answeringQuestionList[f].AnswersID
                                    .indexOf(answeringQuestion.answeringQuestionList[f].answeringList[l].AnswersID) >= 0) {
                                answeringQuestion.answeringQuestionList[f].AnswersNos
                                    = answeringQuestion.answeringQuestionList[f].AnswersNos + answeringQuestion.answeringQuestionList[f].answeringList[l].ANo + ",";
                            }
                        }
                        if (answeringQuestion.answeringQuestionList[f].AnswersNos != "") {
                            answeringQuestion.answeringQuestionList[f].AnswersNos =
                                answeringQuestion.answeringQuestionList[f].AnswersNos.substring(0, answeringQuestion.answeringQuestionList[f].AnswersNos.length - 1);
                        }
                    }

                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        answeringQuestion.fnGetAnsweringQuestionList = fnGetAnsweringQuestionList;
        function fnGetAnsweringQuestionList(btnStr, index, questionId) {
            answeringQuestion.questionList = [];
            if (btnStr == "展开") {
                answeringQuestion.answeringQuestionList[index].btnStr = "关闭";
                answeringQuestion.answeringQuestionList[index].isShow = true;
                loadingService.show();
                learingingBoardService.fnGetAnsweringQuestionList(questionId)
                    .then(function (data) {
                        for (var i = 0; i < data[0].length; i++) {
                            var item = {
                                "AnswerContent": data[0][i].AnswerContent,
                                "Type": data[0][i].Type
                            }
                            answeringQuestion.questionList.push(item);
                        }
                        answeringQuestion.answeringQuestionList[index].questionList = answeringQuestion.questionList;
                        loadingService.hide();
                    }, function (error) {
                        $cordovaToast.showShortBottom('网络出现异常！');
                    });
            } else if (btnStr == "关闭") {
                answeringQuestion.answeringQuestionList[index].questionList = [];
                answeringQuestion.answeringQuestionList[index].btnStr = "展开";
                answeringQuestion.answeringQuestionList[index].isShow = false;
            }

        }

        answeringQuestion.fnSetQuestion = fnSetQuestion;
        //插入答疑2017/10/13
        function fnSetQuestion(questionID, btnStr, index) {
            learingingBoardService.fnSetAnsweringQuestionSave(questionID, answeringQuestion.question)
                .then(function (data) {
                    if (data == "") {
                        answeringQuestion.fnGetAnsweringQuestionList("展开", index, questionID);//因为答疑在展开状态，所以提交也展开 状态不变
                        $cordovaToast.showShortBottom('提交成功！');
                    } else {
                        $cordovaToast.showShortBottom(data);
                    }
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        fnGetMyAnswering();
    }
})();
