/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("myDownloadListController", myDownloadListController);

    function myDownloadListController($rootScope, $cordovaFile, $cordovaNetwork, $ionicHistory, $timeout, $cordovaFileTransfer, $ionicLoading, $cordovaToast, $ionicPopup, $location, $stateParams, loadingService, myVideoService, $interval, accountService) {
        var myDownloadList = this;
        var worker;

        myDownloadList.fnPlayerListGet = fnPlayerListGet;//定义方法
        myDownloadList.fnGoList = fnGoList;//定义返回方法
        myDownloadList.fnVideoSaveSet = fnVideoSaveSet;//定义保存时间方法
        myDownloadList.fnFirstLearning = fnFirstLearning;//定义第一次进入方法
        myDownloadList.VideoLists = new Array();//创建新的数组用来接收数据并展示
        myDownloadList.CourseID = $stateParams.CourseID;
        myDownloadList.ContractID = $stateParams.ContractID;
        myDownloadList.play = play;//定义点击选择方法
        myDownloadList.fnVideoTime = fnVideoTime;//定义时间方法
        myDownloadList.videoItemTime = 0;
        myDownloadList.videoLerningID = "";
        myDownloadList.items = 0;
        myDownloadList.VideoID = "";
        myDownloadList.CustomerID = accountService.fnGetUser().CustomerID;
        var objtimer = null;

        //var list = myVideoService.fnGetVideo();
        //if (list.length > 0) {
        //    myDownloadList.VideoLists = myVideoService.fnGetVideo();
        //}
        myDownloadList.isDownloadNextTrue = true;
        myDownloadList.fnDownloadVideo = fnDownloadVideo;
        function fnDownloadVideo(url, segment, downloadIndex) {
            /**
             * 将方法转至线程
             * @param url
             * @param segment
             * @param downloadIndex
             */
            function downVideo(url, segment, downloadIndex) {
                $cordovaFile.checkFile(cordova.file.externalRootDirectory + "lekaoVideo/", segment).then(function (success) {
                    //alert(cordova.file.externalRootDirectory + "lekaoVideo/" + segment + "已经有下载文件")
                    $cordovaToast.showShortBottom('该视频已下载！');
                }, function (error) {
                    var targetPath = cordova.file.externalRootDirectory + "lekaoVideo/" + segment + ".dat";
                    var trustHosts = true;
                    var options = {};
                    //$cordovaToast.showShortBottom('开始下载!');
                    $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
                        .then(function (result) {
                            // Success!
                            //修改名字
                            $cordovaFile.moveFile(cordova.file.externalRootDirectory + "lekaoVideo/", segment + ".dat", cordova.file.externalRootDirectory + "lekaoVideo/", segment)
                            myDownloadList.VideoLists[downloadIndex].downLoadShow = true;
                            //$cordovaToast.showShortBottom('下载成功！');
                        }, function (err) {
                            // Error
                            //$cordovaToast.showShortBottom('下载失败！');
                        }, function (progress) {
                            myDownloadList.VideoLists[downloadIndex].ProgressItem = Math.floor((progress.loaded / progress.total) * 100) + "%";
                            //myVideoService.fnSetVideo(myDownloadList.VideoLists);
                            if ((progress.loaded / progress.total) * 100 > 99) {
                                myDownloadList.VideoLists[downloadIndex].downLoadShow = true;
                            }

                        });
                });

            }

            //启动doDown脚本
            worker = new Worker("js/controllers/course/doDown.js");

            worker.postMessage(downVideo(url, segment, downloadIndex));

            worker.onmessage = function () {
                //alert("data1------------>:" + event.data)
            };

        }

        /**
         * 返回
         */
        function fnGoList() {
            $interval.cancel(objtimer);
            $ionicHistory.goBack();
        }

        /**
         * 点击切换视频
         * @param url
         */
        function play(url, items, LearningID, VideoID, curVideo) {
            // listen for Online event
            var type = $cordovaNetwork.getNetwork()
            if (type == Connection.WIFI) { //TODO something
                //如果为WiFi开始下载
                $cordovaFile.getFreeDiskSpace()//获取磁盘空间
                    .then(function (success) {
                        if ((success / 1024) > 500) {
                            myDownloadList.fnDownloadVideo(url, curVideo, items);
                        }
                    }, function (error) {

                    });
            }
            else if (type == Connection.CELL_4G || type == Connection.CELL_3G) {
                //TODO something
            }


            if (objtimer != null) {
                myDownloadList.fnVideoSaveSet(LearningID, VideoID, myDownloadList.ContractID, myDownloadList.CustomerID);
                myDownloadList.videoItemTime = 0;
                $interval.cancel(objtimer);
                objtimer = $interval(myDownloadList.fnVideoTime, 1000);
                //$interval.cancel(objtimer);
            }
            myDownloadList.items = items;
            myDownloadList.VideoID = VideoID;
            for (var i = 0; i < myDownloadList.VideoLists.length; i++) {//改变选中的颜色
                myDownloadList.VideoLists[i].color = "#000000";
            }
            myDownloadList.VideoLists[items].videoTime = myDownloadList.videoItemTime;
            myDownloadList.VideoLists[items].LearningID = myDownloadList.videoLerningID;
            myDownloadList.VideoLists[items].color = "#27c0d2";
            if (curVideo != null) {
                $cordovaFile.checkFile(cordova.file.externalRootDirectory + "lekaoVideo/", curVideo).then(function (success) {
                    myDownloadList.VideoLists[items].downLoadShow = true;
                    url = cordova.file.externalRootDirectory + "lekaoVideo/" + curVideo;
                }, function (error) {
                });
            }

        }

        /**
         * 请求我视频
         */
        function fnPlayerListGet() {
            loadingService.show();
            myVideoService.FunPlayerListGet(myDownloadList.CourseID)
                .then(function (data) {
                    if (data == "Video") { //未找到视频
                        var items = {
                            "Segment": "没有找到视频!",
                            "VideoUrl": ""
                        }
                        myDownloadList.VideoLists.push(items);
                        loadingService.hide();
                        return;
                    }

                    //$cordovaFile.checkFile(path, file)


                    //加载视频列表
                    for (var i = 0; i < data[0].length; i++) {
                        var item = {
                            "Segment": data[0][i].Segment,
                            "VideoChapterName": data[0][i].VideoChapterName,
                            "OrderNo": data[0][i].OrderNo,
                            "ChapterID": data[0][i].ChapterID,
                            "ChapterNum": data[0][i].ChapterNum,
                            "VideoUrl": data[0][i].VideoUrl,
                            "VideoID": data[0][i].VideoID,
                            "color": "#000000",
                            "item": i,
                            "videoTime": 0,
                            "LearningID": fnFirstLearning(data[0][i].LearningID),
                            "ProgressItem": 0,//为下载时间的长度赋值
                            "downLoadShow": false,
                            "VFile": data[0][i].VFile //这里是视频的名字
                        }
                        //file:///storage/sdcard0/Download
                        myDownloadList.VideoLists.push(item);
                        //判断缓存中是否有视频


                    }
                    objtimer = $interval(myDownloadList.fnVideoTime, 1000);
                    ////判断是否有名字
                    //if (curVideo != null) {
                    //  //查找是否存当前需要播放的文件
                    //  $cordovaFile.checkFile(cordova.file.externalRootDirectory, curVideo).then(function (success) {
                    //    //存在
                    //    myDownloadList.VideoLists[0].downLoadShow = false;
                    //    myDownloadList.VideoLists[0].VideoUrl = cordova.file.externalRootDirectory + "/" + curVideo;
                    //  }, function (error) {
                    //    //不存在
                    //  });
                    //}
                    //myDownloadList.play(myDownloadList.VideoLists[0].VideoUrl, 0, myDownloadList.VideoLists[0].LearningID, myDownloadList.VideoLists[0].VideoID, myDownloadList.VideoLists[0].VFile);

                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        /**
         * 定义第一次进入方法
         * @param data
         * @returns {*}
         */
        function fnFirstLearning(data) {
            if (data == undefined) {
                return "";
            } else {
                return data;
            }
        }

        //启动方法
        fnPlayerListGet()
        function fnVideoTime() {

        }

        function fnVideoSaveSet(LearningID, VideoID, ContractID, CustomerID) {
            //loadingService.show();
            myVideoService.FunVideoSaveSet(LearningID, VideoID, ContractID, myDownloadList.videoItemTime, CustomerID)
                .then(function (data) {
                    if (data == "CustomerID") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('未登录！');
                        return;
                    }
                    if (data == "error") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('错误！');
                        return;
                    }
                    myDownloadList.videoLerningID = data;
                    //loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }


    }
})()
