/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("homeProductListController", homeProductListController);

    function homeProductListController($state, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, homeService, _customerType) {

        var homeProductList = this;
        homeProductList.fnProductList = fnProductList;
        homeProductList.customerType = false;
        homeProductList.productSubjectID = $stateParams.SubjectID;//接收SubjectID
        homeProductList.productSubjectName = $stateParams.SubjectName;//接收SubjectName

        homeProductList.productDataList = [];//总的数据List

        homeProductList.productList = [];//课程列表数组
        homeProductList.productLists = [];//顶上按钮数组
        homeProductList.unique = unique;//判断当前item是否存在
        homeProductList.clickId = clickId;//判断点击的id
        homeProductList.fnGoList = fnGoList;//返回按钮
        /**
         * 产品列表
         */
        function fnProductList() {
            loadingService.show();
            _customerType = homeProductList.customerType ? 1 : 0;
            homeService.fnHomeProductList(homeProductList.productSubjectID)
                .then(function (data) {
                    homeProductList.productDataList = data[0];

                    for (var i = 0; i < data[0].length; i++) {
                        var items = {
                            "itemId": 0,
                            "ProducTypeID": data[0][i].ProducTypeID,
                            "ProducTypeName": data[0][i].ProducTypeName,
                            "CourseID": data[0][i].CourseID,
                            "ChapterID": data[0][i].ChapterID,
                            "color": '#000000',
                            "borderColor": '#ffffff'
                        }
                        if (unique(items.ProducTypeID, homeProductList.productLists)) {
                            homeProductList.productLists.push(items);
                        }
                    }

                    for (var d = 0; d < homeProductList.productLists.length; d++) {
                        homeProductList.productLists[d].itemId = d;
                    }


                    for (var k = 0; k < data[0].length; k++) {

                        if (homeProductList.productLists[0].ProducTypeID == data[0][k].ProducTypeID) {
                            var item = {
                                "SubjectID": data[0][k].SubjectID,
                                "ProductName": data[0][k].ProductName,
                                "learningTime": data[0][k].learningTime,
                                "ProductID": data[0][k].ProductID,
                                "Category": data[0][k].Category,
                                "ProducTypeID": data[0][k].ProducTypeID,
                                "ProducTypeName": data[0][k].ProducTypeName,
                            }
                            homeProductList.productList.push(item);
                        }
                    }
                    homeProductList.productLists[0].color = "#387ef7";//默认颜色 2017/8/17
                    homeProductList.productLists[0].borderColor = "#387ef7";//默认颜色 2017/8/17
                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        /**
         * 判断当前item是否存在
         */
        fnProductList()
        function unique(items, arr) {
            for (var j = 0; j < arr.length; j++) {
                if (items == arr[j].ProducTypeID) {
                    return false;
                }
            }
            return true;
        }

        /**
         * 判断点击的id
         */
        function clickId(i) {
            loadingService.show();
            //$window.location.reload();
            //改变点击颜色 2017/8/17
            for (var z = 0; z < homeProductList.productLists.length; z++) {
                if (i == z) {
                    homeProductList.productLists[i].color = "#387ef7";
                    homeProductList.productLists[i].borderColor = "#387ef7";
                } else {
                    homeProductList.productLists[z].color = "#000000"
                    homeProductList.productLists[z].borderColor = "#ffffff"
                }
            }
            homeProductList.productList = [];
            for (var y = 0; y < homeProductList.productDataList.length; y++) {
                if (homeProductList.productDataList[y].ProducTypeID == homeProductList.productLists[i].ProducTypeID) {
                    var listItem = {
                        "ProductName": homeProductList.productDataList[y].ProductName,
                        "learningTime": homeProductList.productDataList[y].learningTime,
                        "ProductID": homeProductList.productDataList[y].ProductID,
                        "Category": homeProductList.productDataList[y].Category,
                        "ProducTypeID": homeProductList.productDataList[y].ProducTypeID,
                        "ProducTypeName": homeProductList.productDataList[y].ProducTypeName,
                    }
                    homeProductList.productList.push(listItem);
                }
            }
            loadingService.hide();
        }

        function fnGoList() {
            $state.go('tab.home');
            //$location.path("tab/home");
        }
    }
})()
