/**
 * Created by zjw-pc on 2017/10/30.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("liveBroadcastInfoController", liveBroadcastInfoController);

  function liveBroadcastInfoController($ionicActionSheet, $sce, $ionicPopup, accountService, $stateParams, liveBroadcastService, $scope, $ionicHistory, $location, $cordovaToast, loadingService, $ionicPopover, _customerType, _version) {
    var liveBroadcastInfo = this;
    liveBroadcastInfo.fnBack = fnBack;
    function fnBack() {
      $ionicHistory.goBack();
    }

    liveBroadcastInfo.ID = $stateParams.ID;//获取直播ID
    liveBroadcastInfo.Name = $stateParams.Name;//获取直播Name

    liveBroadcastInfo.btn1BgColor = "#0a9dc7"; //背景颜色1
    liveBroadcastInfo.btn2BgColor = "#f8f8f8";//背景颜色2
    liveBroadcastInfo.btn1Color = "#ffffff";//字体颜色1
    liveBroadcastInfo.btn2Color = "#000000";//字体颜色2
    liveBroadcastInfo.btnClick = btnClick;//点击切换方法
    liveBroadcastInfo.isShow = false;
    function btnClick(index) {
      switch (index) {
        case 0:
          liveBroadcastInfo.isShow = false;
          liveBroadcastInfo.btn1BgColor = "#0a9dc7"; //背景颜色1
          liveBroadcastInfo.btn2BgColor = "#f8f8f8";//背景颜色2
          liveBroadcastInfo.btn1Color = "#ffffff";//字体颜色1
          liveBroadcastInfo.btn2Color = "#000000";//字体颜色2
          break;
        case 1:
          liveBroadcastInfo.isShow = true;
          liveBroadcastInfo.btn1BgColor = "#f8f8f8"; //背景颜色1
          liveBroadcastInfo.btn2BgColor = "#0a9dc7";//背景颜色2
          liveBroadcastInfo.btn1Color = "#000000";//字体颜色1
          liveBroadcastInfo.btn2Color = "#ffffff";//字体颜色2
          break;
      }
    }

    /**
     * 分享方法
     * @type {shareWechat}
     */
    liveBroadcastInfo.shareWechat = shareWechat;
    function shareWechat() {
      var hideSheet = $ionicActionSheet.show({
        buttons: [
          {text: ' <div class="close-btn"><div class="img-responsive"> <img src="img/wxhy.png"  width="30px" height="30px"></div><div class="close">微信分享好友</div></div>'},
          {text: '<div class="close-btn"><div class="img-responsive"> <img src="img/wxpyq.png"  width="30px" height="30px"></div><div class="close">朋友圈分享</div></div>'}
        ]
      })
      if (typeof Wechat !== 'undefined') {
        Wechat.isInstalled(function (installed) {
          //alert("Wechat installed: " + (installed ? "Yes" : "No"));
          var hideSheet = $ionicActionSheet.show({
            buttons: [
              {text: ' <div class="close-btn"><div class="img-responsive"> <img src="img/wxhy.png"  width="30px" height="30px"></div><div class="close">微信分享好友</div></div>'},
              {text: '<div class="close-btn"><div class="img-responsive"> <img src="img/wxpyq.png"  width="30px" height="30px"></div><div class="close">朋友圈分享</div></div>'}
            ],
            //titleText: '选择分享给',
            cancelText: '取消',
            cancel: function () {
              // add cancel code..
            },
            buttonClicked: function (index) {
              switch (index) {
                case 0:
                  Wechat.share({
                    message: {
                      title: "Hi, 我正在看乐考直播",
                      description: liveBroadcastInfo.Name,
                      thumb: liveBroadcastInfo.dataUrl + liveBroadcastInfo.infoList.Picture,
                      media: {
                        type: Wechat.Type.WEBPAGE,
                        webpageUrl: "http://wap.lekaowang.cn"
                      }
                    },
                    scene: Wechat.Scene.SESSION // 聊天界面
                  }, function () {
                    $cordovaToast.showShortBottom('分享成功！');
                    //alert("Success");
                  }, function (reason) {
                    //alert("Failed: " + reason);
                    $cordovaToast.showShortBottom('分享失败！' + reason);
                  });
                  break;
                case 1:
                  Wechat.share({
                    message: {
                      title: "Hi, 我正在看乐考直播",
                      description: liveBroadcastInfo.Name,
                      thumb: liveBroadcastInfo.dataUrl + liveBroadcastInfo.infoList.Picture,
                      media: {
                        type: Wechat.Type.WEBPAGE,
                        webpageUrl: "http://wap.lekaowang.cn"
                      }
                    },
                    scene: Wechat.Scene.TIMELINE   // share to Timeline 朋友圈
                  }, function () {
                    $cordovaToast.showShortBottom('分享成功！');
                    //alert("Success");
                  }, function (reason) {
                    $cordovaToast.showShortBottom('分享失败！' + reason);
                    //alert("Failed: " + reason);
                  });
                  break;
              }
              return true;
            }
          });
        }, function (reason) {
          $cordovaToast.showShortBottom(reason);
          //alert("Failed: " + reason);
        });

      }


    }

    /**
     * 进入直播页
     * @type {goLiveBroadcast}
     */
    liveBroadcastInfo.goLiveBroadcast = goLiveBroadcast;
    function goLiveBroadcast() {
      if (liveBroadcastInfo.signUpText == "开始回放") {
        if (isLogin()) {
          document.getElementById('myLive').play();
        }
      }
      else if (liveBroadcastInfo.signUpText == "进入直播") {
        if (isLogin()) {
          $location.path("tab/broadcast/" + liveBroadcastInfo.infoList.ProductID)
        }
      }
    }

    /**
     * 报名方法
     * @type {signUp}
     */
    liveBroadcastInfo.signUp = signUp;
    liveBroadcastInfo.signUpText = "立即报名";
    function signUp(ProductID) {
      //按钮为 "立即报名" 且用户登录了
      if (liveBroadcastInfo.signUpText == "立即报名") {
        if (isLogin()) {
          loadingService.show();
          liveBroadcastService.funLiveFreePay(ProductID)
            .then(function (data) {
                if (data == "error") {
                  $cordovaToast.showShortBottom('系统错误！');
                } else if (data == "Amount") {
                  //生成订单 跳转支付
                  $location.path("/my/bill/" + liveBroadcastInfo.infoList.ProductID + "/0");
                } else if (data == "CustomerID") {
                  $cordovaToast.showShortBottom('系统错误！');
                } else if (data == "") {
                  liveBroadcastInfo.signUpText = "已经报名";
                  liveBroadcastInfo.infoList.people -= 1;//报名人数减少
                  if (liveBroadcastInfo.infoList.people < 0) {
                    liveBroadcastInfo.infoList.people = 0;
                  }
                  liveBroadcastInfo.loadNewerStories();
                }
                loadingService.hide();
              }, function (error) {
                $cordovaToast.showShortBottom('网络出现异常！');
              }
            );
        }
      }
      //报名满了 不进点击里面方法
      else if (liveBroadcastInfo.signUpText != "报名已满") {
      }
      //已经报名了
      else if (liveBroadcastInfo.signUpText != "已经报名") {
      }


      //liveBroadcastInfo.signUpText = "报名成功";
      //alert(liveBroadcastInfo.signUpText)
    }

    function isLogin() {
      if (accountService.fnGetUser().CustomerID == undefined) {
        var alertPopup = $ionicPopup.alert({
          title: '用户验证',
          template: '您尚未有登录系统'
        });
        alertPopup.then(function (res) {
          $location.path("/tab/userLogin");
        });
        return false;
      } else {
        return true;
      }
    }

    liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
    function btnClass(data) {
      if (accountService.fnGetUser().CustomerID == undefined) {
        if (liveBroadcastInfo.infoList.people > 0) {
          if (parseInt(data.Amount) > 0 && accountService.fnGetUser().CustomerID != undefined) {
            liveBroadcastInfo.signUpText = "立即报名";
            liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
            liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
            liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
          }
          else {
            liveBroadcastInfo.signUpText = "立即报名";
            liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
            liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
            liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
          }
        }
        else {
          //添加回放不限制人数 2017/12/12
          if (data.status == "2") {
            if (parseInt(data.Amount) > 0 && accountService.fnGetUser().CustomerID != undefined) {
              liveBroadcastInfo.signUpText = "立即报名";
              liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
              liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
              liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
            }
            else {
              liveBroadcastInfo.signUpText = "立即报名";
              liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
              liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
              liveBroadcastInfo.isShowPeople = false;//控制是否显示报名人数的 2017/12/13
            }
          }
          else {
            liveBroadcastInfo.signUpText = "报名已满";
            liveBroadcastInfo.btnOnColor = "#5d5d5d";//2017/11/17 修改报名已满的颜色
            liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
            liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
            liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
          }
        }

      }
      else {
        if (data.IQty != "0") {
          if (data.status == "1") {
            liveBroadcastInfo.signUpText = "已经报名";
            liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
            liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
            liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
          }
          else if (data.status == "3") {
            liveBroadcastInfo.signUpText = "进入直播";
            liveBroadcastInfo.isShowVideo2 = true;//控制是否显示viedo 回放的
            liveBroadcastInfo.isShowVideo1 = false;//控制是否显示报名的
            liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
          }
          else {
            liveBroadcastInfo.signUpText = "开始回放";
            liveBroadcastInfo.isShowVideo2 = true;//控制是否显示viedo 回放的
            liveBroadcastInfo.isShowVideo1 = false;//控制是否显示报名的
            liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
            //PlaybackUrl = LiveInfo.Tables[0].Rows[0]["PlaybackAddress"].ToString();

          }
        }
        else {

          if (liveBroadcastInfo.infoList.people > 0) {
            if (parseInt(data.Amount) > 0 && accountService.fnGetUser().CustomerID != undefined) {
              liveBroadcastInfo.signUpText = "立即报名";
              liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
              liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
              liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
            }
            else {
              liveBroadcastInfo.signUpText = "立即报名";
              liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
              liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
              liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
            }
          }
          else {
            //添加回放不限制人数 2017/12/12
            if (data.status == "2") {
              if (parseInt(data.Amount) > 0 && accountService.fnGetUser().CustomerID != undefined) {
                liveBroadcastInfo.signUpText = "立即报名";
                liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
                liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
                liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
              }
              else {
                liveBroadcastInfo.signUpText = "立即报名";
                liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
                liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
                liveBroadcastInfo.isShowPeople = false;//控制是否显示报名人数的 2017/12/13
              }
            }
            else {
              liveBroadcastInfo.signUpText = "报名已满";
              liveBroadcastInfo.btnOnColor = "#5d5d5d";//2017/11/17 修改报名已满的颜色
              liveBroadcastInfo.isShowVideo1 = true;//控制是否显示报名的
              liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
              liveBroadcastInfo.isShowPeople = true;//控制是否显示报名人数的 2017/12/13
            }
          }
        }
      }
    }


    liveBroadcastInfo.infoList = [];
    liveBroadcastInfo.isShowVideo1 = false;//控制是否显示报名的
    liveBroadcastInfo.isShowVideo2 = false;//控制是否显示viedo 回放的
    liveBroadcastInfo.isShowBtnBar = false;//控制是否显示底部按钮组
    liveBroadcastInfo.dataUrl = "http://www.lekaowang.cn";//图片地址
    liveBroadcastInfo.dataVideoUrl = "http://video.lekaowang.cn/";//视频地址
    liveBroadcastInfo.fnGetLiveInfo = fnGetLiveInfo;
    function fnGetLiveInfo() {
      loadingService.show();
      liveBroadcastService.funGetLiveInfo(liveBroadcastInfo.ID)
        .then(function (data) {
            liveBroadcastInfo.infoList = data[0][0];
            //控制显示报名人数 全部-已经报名的
            liveBroadcastInfo.infoList.people = parseInt(liveBroadcastInfo.infoList.LiveMaxPersonCount)
              - parseInt(liveBroadcastInfo.infoList.doLiveQty);
            if (liveBroadcastInfo.infoList.people < 0) {
              liveBroadcastInfo.infoList.people = 0;
            }
            btnClass(liveBroadcastInfo.infoList);
            liveBroadcastInfo.isShowBtnBar = true;//加载完显示按钮组
            if (liveBroadcastInfo.signUpText == "开始回放" && liveBroadcastInfo.infoList.PlaybackAddress != "") {
              //$sce.trustAsResourceUrl 处理一下URL
              liveBroadcastInfo.videoSrc = $sce.trustAsResourceUrl(liveBroadcastInfo.dataVideoUrl
                + liveBroadcastInfo.infoList.PlaybackAddress);
            }
            loadingService.hide();
          }, function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }

    liveBroadcastInfo.loadNewerStories = loadNewerStories;//刷新方法
    function loadNewerStories() {
      liveBroadcastInfo.infoList = [];
      fnGetLiveInfo();
      //window.location.reload();
      $scope.$broadcast('scroll.refreshComplete');//广播结束
    }

    fnGetLiveInfo();
  }
})();
