/**
 * Created by zjw-pc on 2017/10/30.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("liveBroadcastController", liveBroadcastController);

  function liveBroadcastController($ionicSlideBoxDelegate, accountService, liveBroadcastService, $scope, $location, $state, $cordovaToast, loadingService, $ionicPopover, _customerType, _version) {
    var liveBroadcastList = this;
    liveBroadcastList.fnBack = fnBack;
    function fnBack() {
      $state.go('tab.home');
    }

    liveBroadcastList.fnStartInfo = fnStartInfo;//进入详情页
    function fnStartInfo(datasID, datasName) {
      $location.path('tab/liveBroadcastInfo/' + datasID + "/" + datasName);
    }

    liveBroadcastList.fnLiveBanner = fnLiveBanner;
    function fnLiveBanner() {
      loadingService.show();
      liveBroadcastService.funLiveBanner()
        .then(function (data) {
            liveBroadcastList.bannerList = [];
            liveBroadcastList.bannerList = data[0]; //赋值给图片数组
            $ionicSlideBoxDelegate.update();//更新banner
            //$ionicSlideBoxDelegate.$getByHandle("slideboximgs").loop(true);//循环播放
            loadingService.hide();
          }, function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }

    /**
     * 打开subject的弹窗方法
     * @type {popoverSubjectShow}
     */
    liveBroadcastList.popoverSubjectShow = popoverSubjectShow;
    liveBroadcastList.popoverSubjectClose = popoverSubjectClose;
    $ionicPopover.fromTemplateUrl('subject-pop.html', {
      scope: $scope
    }).then(function (popover) {
      liveBroadcastList.popover1 = popover;
    });
    function popoverSubjectShow($event) {
      liveBroadcastList.popover1.show($event);
    }

    $scope.$on('popover.hidden', function () {
      // 执行代码
    });
    function popoverSubjectClose($event) {
      liveBroadcastList.popover1.hide();
    }

    liveBroadcastList.lists = [
      {
        "SubjectID": "",
        "SubjectName": "全部课程",
        "SubjectColor": "#ff0000" //默认全部 红色
      },
      {
        "SubjectID": "a0b27d37-0559-4695-b948-1e031adb82fc",
        "SubjectName": "基金",
        "SubjectColor": "#7a9fbc"
      },
      {
        "SubjectID": "30565d81-abc8-4192-9a89-247af4c00265",
        "SubjectName": "经济师",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "6f56ba18-7a89-40cd-9304-27a159388ad1",
        "SubjectName": "期货",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "4bad7c0d-a00f-46db-b09b-4691dce553fe",
        "SubjectName": "银行",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "a6c2d781-2187-426f-9399-5cf3fc9340a6",
        "SubjectName": "CFA",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "6d376160-e3ed-42aa-ae39-89065554735d",
        "SubjectName": "证券",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "654400fb-7429-4261-be28-8f557aa94911",
        "SubjectName": "会计",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "7feff67b-9947-464a-a901-e8e96635afe9",
        "SubjectName": "CPA",
        "SubjectColor": "#7a9fbc"
      }

    ];//课程数组
    liveBroadcastList.allSubject = "全部课程";
    liveBroadcastList.calendar = "日历显示";


    liveBroadcastList.onclickCalendar = onclickCalendar;//日历显示
    function onclickCalendar() {
      //liveBroadcastList.calendar = "列表显示";
      $location.path('tab/liveBroadcastCalendar/' + liveBroadcastList.allSubject + '/' + liveBroadcastList.idxType);//直播和回放的状态 2017/11/22
    }

    liveBroadcastList.onClickListener = onClickListener;//全部课程的点击方法
    function onClickListener(inx) {
      //循环赋值颜色
      for (var i in liveBroadcastList.lists) {
        if (i == inx) {
          liveBroadcastList.lists[i].SubjectColor = "#ff0000";
        } else {
          liveBroadcastList.lists[i].SubjectColor = "#7a9fbc";
        }
      }
      liveBroadcastList.allSubject = liveBroadcastList.lists[inx].SubjectName;
      liveBroadcastList.fnLiveView("subject", liveBroadcastList.lists[inx].SubjectID, "", "");
      popoverSubjectClose();
    }

    liveBroadcastList.btnOnClickListener = btnOnClickListener;//footbar 点击事件
    liveBroadcastList.isShowBtn = true;
    liveBroadcastList.btnBarColor1 = "#F9FF00";
    liveBroadcastList.btnBarColor2 = "#ffffff";
    liveBroadcastList.idxType = 1;//直播和回放的状态 2017/11/22
    function btnOnClickListener(index) {
      liveBroadcastList.idxType = index;//直播和回放的状态 2017/11/22
      //判断课程是否有 2017/11/8
      if (liveBroadcastList.btn2List.length <= 0 && liveBroadcastList.isShowBtn) {
        $cordovaToast.showShortBottom('当前科目无回放！');
      }
      if (liveBroadcastList.btn1List.length <= 0 && !liveBroadcastList.isShowBtn) {
        $cordovaToast.showShortBottom('当前科目无直播！');
      }
      switch (index) {
        case 1:
          liveBroadcastList.btnBarColor1 = "#F9FF00";
          liveBroadcastList.btnBarColor2 = "#ffffff";
          liveBroadcastList.isShowBtn = true;
          break;
        case 2:
          liveBroadcastList.btnBarColor1 = "#ffffff";
          liveBroadcastList.btnBarColor2 = "#F9FF00";
          liveBroadcastList.isShowBtn = false;
          break;
      }
    }


    /**
     * 直播列表显示
     * @param SearchType
     * @param subjectid
     * @param StartDate
     * @param EndDate
     */
    liveBroadcastList.dataUrl = "http://www.lekaowang.cn";
    liveBroadcastList.lvBrList = [];
    liveBroadcastList.btn1List = [];
    liveBroadcastList.btn2List = [];
    liveBroadcastList.fnLiveView = fnLiveView;
    function fnLiveView(SearchType, subjectid, StartDate, EndDate) {
      loadingService.show();
      liveBroadcastService.funLiveView(SearchType, "", subjectid, StartDate, EndDate)
        .then(function (data) {
            liveBroadcastList.lvBrList = [];
            liveBroadcastList.btn1List = [];
            liveBroadcastList.btn2List = [];
            liveBroadcastList.isShowList = false;
            if (data.length <= 0) {
              liveBroadcastList.isShowList = true;
            } else {
              liveBroadcastList.lvBrList = data[0];
              buttonClass(data[0]);
              for (var i = 0; i < liveBroadcastList.lvBrList.length; i++) {
                if (liveBroadcastList.lvBrList[i].btnName == "进入回放") {
                  liveBroadcastList.btn2List.push(liveBroadcastList.lvBrList[i]);
                } else {
                  liveBroadcastList.btn1List.push(liveBroadcastList.lvBrList[i]);
                }
              }
              //判断课程是否有 2017/11/8
              if (liveBroadcastList.btn2List.length <= 0 && !liveBroadcastList.isShowBtn) {
                $cordovaToast.showShortBottom('当前科目无回放！');
              }
              if (liveBroadcastList.btn1List.length <= 0 && liveBroadcastList.isShowBtn) {
                $cordovaToast.showShortBottom('当前科目无直播！');
              }
            }
            loadingService.hide();
          }, function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }


    /**
     * 初始化列表方法
     */
    fnLiveView("subject", "", "", "");
    fnLiveBanner();
    liveBroadcastList.loadNewerStories = loadNewerStories;//刷新
    function loadNewerStories() {
      liveBroadcastList.lvBrList = [];
      liveBroadcastList.btn1List = [];
      liveBroadcastList.btn2List = [];
      liveBroadcastList.bannerList = []; //清空图片数组
      fnLiveView("subject", "", "", "");
      fnLiveBanner();
      //window.location.reload();
      $scope.$broadcast('scroll.refreshComplete');//广播结束
    }

    //判断按钮状态
    function buttonClass(data) {
      for (var i = 0; i < data.length; i++) {
        if (accountService.fnGetUser().CustomerID == undefined) {
          if (data[i].status == "2") {
            data[i].btnName = "进入回放";
          } else if (data[i].status == "3") {
            data[i].btnName = "进入直播";
          } else {
            if (parseInt(data[i].LiveMaxPersonCount) - parseInt(data[i].doLiveQty) > 0) {
              data[i].btnName = "立即报名";
            } else {
              data[i].btnName = "报名已满";
            }
          }
        }
        else {
          if (data[i].status == "1") {
            if (parseInt(data[i].IQty) > 0) {
              data[i].btnName = "已经报名";
            } else if (parseInt(data[i].LiveMaxPersonCount) - parseInt(data[i].doLiveQty) > 0) {
              data[i].btnName = "立即报名";
            } else {
              data[i].btnName = "报名已满";
            }
          } else if (data[i].status == "3") {
            data[i].btnName = "进入直播";
          } else {
            data[i].btnName = "进入回放";
          }
        }
      }
    }

  }
})();
