/**
 * Created by zjw-pc on 2016/16/17.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("shopController", shopController);

    function shopController($location, $scope, myBillService, accountService, $cordovaToast, shopService, loadingService) {
        var shop = this;
        shop.shopCartList = [];
        shop.customerID = accountService.fnGetUser().CustomerID;//获取customerID
        shop.isShowShop = false;//购物车没有课程，不显示
        shop.loadNewerStories = loadNewerStories;//刷新方法
        //初始化赋值
        function fnInitDat() {
            if (shopService.fnGetShopCart().length > 0) {
                shop.isShowShop = true;//购物车有课程，显示
            } else {
                shop.isShowShop = false;//购物车没有课程，不显示
            }
            for (var i = 0; i < shopService.fnGetShopCart().length; i++) {
                var item = {
                    "checked": true,
                    "ProductID": shopService.fnGetShopCart()[i].ProductID,
                    "ProductName": shopService.fnGetShopCart()[i].ProductName,
                    "Amount": shopService.fnGetShopCart()[i].Amount
                }
                shop.shopCartList.push(item);
            }
        }

        shop.fnClick = fnClick;//声明CheckBox点击事件
        function fnClick() {
            shop.shopSum = 0;//每次启动方法计算时将总数清零
            for (var j = 0; j < shop.shopCartList.length; j++) {//循环数字
                if (shop.shopCartList[j].checked) {//判断确定选中
                    shop.shopSum += parseFloat(shop.shopCartList[j].Amount);//累加求和
                }
            }
            shop.shopSum = parseFloat(shop.shopSum).toFixed(2);
        }

        fnInitDat();//初始化赋值
        fnClick();//初始化总和
        /**
         *删除数组中数据的点击方法
         * @type {fnDeleteItem}
         */
        shop.fnDeleteItem = fnDeleteItem;
        function fnDeleteItem() {

            for (var j = 0; j < shopService.fnGetShopCart().length; j++) {
                if (shop.shopCartList[j].checked) {//判断确定选中
                    shop.shopCartList.remove(j);
                    shopService.fnSetShopCart(shop.shopCartList);
                    j = j - 1//查询的时候数组长度是会变的，这里改变每次都是取新的长度
                }
            }
            loadNewerStories();
        }

        /**
         *删除数组中的一组数据
         * @param from
         * @param to
         * @returns {Number}
         */
        Array.prototype.remove = function (from, to) {
            var rest = this.slice((to || from) + 1 || this.length);
            this.length = from < 0 ? this.length + from : from;
            return this.push.apply(this, rest);
        };

        /**
         * 提交方法
         * @type {fnCommitData}
         */
        shop.fnCommitData = fnCommitData;
        function fnCommitData() {
            var productIDString = "";
            for (var j = 0; j < shopService.fnGetShopCart().length; j++) {
                if (shop.shopCartList[j].checked) {//判断确定选中
                    if (productIDString == "") {
                        productIDString = shop.shopCartList[j].ProductID;
                    } else {
                        productIDString = productIDString + "," + shop.shopCartList[j].ProductID
                    }
                }
            }
            if (productIDString != "") {
                $location.path("/my/bill/" + productIDString + "/1");
            }else {
                $cordovaToast.showShortBottom('请先选择科目！');
            }

        }


        /**
         * 刷新方法
         */
        function loadNewerStories() {
            //shop.shopCartList = shopService.fnGetShopCart();
            shop.shopCartList = [];
            fnInitDat();//初始化赋值
            fnClick();//初始化总和

            $scope.$broadcast('scroll.refreshComplete');//广播结束
        }


    }
})();
