/**
 * Created by zjw-pc on 2016/5/23.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("questionController", questionController);

  function questionController($ionicPopup,$location, $cordovaToast, loadingService, wikipediaService, _customerType) {
    var question = this;
    question.fnProblemList = fnProblemList;//请求问题列表方法
    question.ProblemList = new Array();//用来接收数据的数组
    question.ProblemListTitle = new Array();//用来存标题
    question.ProblemData = new Array();
    question.unique = unique;//判断当前item是否存在
    question.clickId = clickId;//使用问题和学习问题选择
    question.itemClickListener = itemClickListener;//点击隐藏显示方法
    question.studyColor = "#387ef7";//学习颜色
    question.useColor = "#aaaaaa";//使用颜色
    /**
     * 请求问题列表
     */
    function fnProblemList() {
      loadingService.show();
      //暂时问题列表就34条
      wikipediaService.FunProblemList(1, 34)
        .then(function (data) {
          question.ProblemData = data[0];//将数据放入 question.ProblemData 数组中
          //循环取出SortID
          for (var i = 0; i < data[0].length; i++) {
            var items = {
              "SortID": data[0][i].SortID,
              "SortTitle": data[0][i].SortTitle
            }
            if (unique(items.SortID, question.ProblemListTitle)) {
              question.ProblemListTitle.push(items);
            }
          }
          //循环填入学习问题 设为默认
          for (var k = 0; k < data[0].length; k++) {
            if (question.ProblemListTitle[0].SortID == data[0][k].SortID) {
              var item = {
                "itemId": 0,
                "isShow": false,
                "Answer": data[0][k].Answer,
                "Problem": data[0][k].Problem,
                "SortID": data[0][k].SortID,
                "SortTitle": data[0][k].SortTitle,
                "CreateTime": data[0][k].CreateTime,
              }
              question.ProblemList.push(item);
            }
          }
          //循环加入itemId
          for (var d = 0; d < question.ProblemList.length; d++) {
            question.ProblemList[d].itemId = d;
          }

          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    fnProblemList();//方法开启
    /**
     * 判断当前item是否存在
     */
    function unique(items, arr) {
      for (var j = 0; j < arr.length; j++) {
        if (items == arr[j].SortID) {
          return false;
        }
      }
      return true;
    }

    /**
     * 判断点击的id
     */
    function clickId(i) {
      loadingService.show();
      question.ProblemList = new Array();
      //判断点击的sortID与title中的是否匹配  加入到数组
      for (var y = 0; y < question.ProblemData.length; y++) {
        if (question.ProblemData[y].SortID == question.ProblemListTitle[i].SortID) {
          var listItem = {
            "itemId": 0,
            "isShow": false,
            "Answer": question.ProblemData[y].Answer,
            "Problem": question.ProblemData[y].Problem,
            "SortID": question.ProblemData[y].SortID,
            "SortTitle": question.ProblemData[y].SortTitle,
            "CreateTime": question.ProblemData[y].CreateTime,
          }
          question.ProblemList.push(listItem);
        }
      }

      if (i == 0) {
        question.studyColor = "#387ef7";
        question.useColor = "#aaaaaa";
      }
      if (i == 1) {
        question.studyColor = "#aaaaaa";
        question.useColor = "#387ef7";
      }
      //循环加入itemId
      for (var d = 0; d < question.ProblemList.length; d++) {
        question.ProblemList[d].itemId = d;
      }
      loadingService.hide();
    }

    /**
     * 点击item显示隐藏
     */
    function itemClickListener(itemId) {
      question.ProblemList[itemId].isShow = !question.ProblemList[itemId].isShow;
    }
  }
})()
