/**
 * Created by trueideal on 2016/5/11.
 */
(function () {
    'use strict';//严格模式
    angular.module("myApp").config(config);
    function config($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $ionicConfigProvider.platform.ios.tabs.style('standard');
        $ionicConfigProvider.platform.ios.tabs.position('bottom');
        $ionicConfigProvider.platform.android.tabs.style('standard');
        $ionicConfigProvider.platform.android.tabs.position('standard');

        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
        $ionicConfigProvider.platform.android.navBar.alignTitle('left');

        $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
        $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

        $ionicConfigProvider.platform.ios.views.transition('ios');
        $ionicConfigProvider.platform.android.views.transition('android');

        $ionicConfigProvider.navBar.alignTitle("center");


        $stateProvider

        // setup an abstract state for the tabs directive
            .state('tab', {
                url: '/tab',
                abstract: true,
                templateUrl: 'layout/tabs.html',
                controller: 'tabsController',
                controllerAs: 'tabs'
            })


            /**
             * 首页
             */
            .state('tab.home', {
                url: '/home',
                views: {
                    'tab-home': {
                        templateUrl: 'layout/home/tab.home.tpl.html',
                        controller: 'homeController',
                        controllerAs: 'homeProductIsTop'
                    }
                }

            })


            /**
             * 直播列表
             */
            .state('liveBroadcast', {
                //cache:false,
                url: '/tab/liveBroadcast',
                templateUrl: 'layout/broadcast/tab.liveBroadcast.list.tpl.html',
                controller: "liveBroadcastController",
                controllerAs: "liveBroadcastList"
            })

            /**
             * 直播列表 日历
             */
            .state('liveBroadcastCalendar', {
                //cache:false,
                url: '/tab/liveBroadcastCalendar/:typeName/:idxType',//增加参数
                templateUrl: 'layout/broadcast/tab.liveBroadcast.calendar.tpl.html',
                controller: "liveBroadcastCalendarController",
                controllerAs: "liveBroadcastCalendar"
            })

            /**
             * 直播详情
             */
            .state('liveBroadcastInfo', {
                url: '/tab/liveBroadcastInfo/:ID/:Name',
                templateUrl: 'layout/broadcast/tab.liveBroadcast.info.tpl.html',
                controller: "liveBroadcastInfoController",
                controllerAs: "liveBroadcastInfo"
            })

            /**
             * 我的直播
             */
            .state('myLiveBroadcast', {
                url: '/my/myLiveBroadcast',
                templateUrl: 'layout/broadcast/my.liveBroadcast.tpl.html',
                controller: "myLiveBroadcastController",
                controllerAs: "myLiveBroadcast"
            })
            /**
             * 直播内容页
             */
            .state('broadcast', {
                url: '/tab/broadcast/:ProductID',
                templateUrl: 'layout/broadcast/liveBroadcast.tpl.html',
                controller: "broadcastController",
                controllerAs: "broadcast"
            })


            /**
             * 宝典
             */
            .state('tab.wikipedia', {
                url: '/wikipedia',
                views: {
                    'tab-wikipedia': {
                        templateUrl: 'layout/wikipedia/tab.wikipedia.tpl.html',
                        controller: 'wikipediaController',
                        controllerAs: 'wikipedia'
                    }
                }
            })

            /**
             * 宝典----常见问题
             */
            .state('tab.question', {
                url: '/question',
                views: {
                    'tab-wikipedia': {
                        templateUrl: 'layout/wikipedia/tab.question.tpl.html',
                        controller: 'questionController',
                        controllerAs: 'question'
                    }
                }
            })
            /**
             * 宝典-新闻页
             */
            .state('tab.wikipediaNews', {
                url: '/wikipediaNews/:newID/:newTitle',
                views: {
                    'tab-wikipedia': {
                        templateUrl: 'layout/wikipedia/tab.wikipedia.news.tpl.html',
                        controller: 'wikipediaNewsController',
                        controllerAs: 'wikipediaNews'
                    }
                }

            })

            /**
             * 购物车2016/16/17
             */
            .state('tab.shop', {
                cache: false,
                url: '/shop',
                views: {
                    'tab-shop': {
                        templateUrl: 'layout/shop/tab.shop.tpl.html',
                        controller: 'shopController',
                        controllerAs: 'shop'
                    }
                }
            })

            /***
             * 我的
             */
            .state('tab.person', {
                cache: false,
                url: '/person',
                views: {
                    'tab-person': {
                        templateUrl: 'layout/account/tab.person.html',
                        controller: 'personController',
                        controllerAs: 'person'
                    }
                }
            })
            /**
             *
             * 登录  注册
             */
            /**
             * 登录
             */
            .state('userLogin', {
                //cache: false,
                url: '/tab/userLogin',
                templateUrl: 'layout/account/tab.userlogin.tpl.html',
                controller: "userLoginController",
                controllerAs: "userLogin"
            })



            /**
             * 注册
             */
            .state('register', {
                url: '/tab/register',
                templateUrl: 'layout/account/tab.register.html',
                controller: "userRegisterController",
                controllerAs: "userRegister"
            })
            /**
             * 忘记密码 请输入手机
             */
            .state('findPassword', {
                url: '/tab/findPassword',
                templateUrl: 'layout/account/tab.forgot.password.tpl.html',
                controller: "forgotPasswordController",
                controllerAs: "findPassword"
            })
            /**
             * 忘记密码 输入验证码 输入密码
             */
            .state('changePassword', {
                url: '/tab/changePassword/:Tel',
                templateUrl: 'layout/account/tab.change.password.tpl.html',
                controller: "changePasswordController",
                controllerAs: "changePassword"
            })

            /**
             * 修改资料
             */
            .state('tab.modifyData', {
                cache: false,
                url: '/modifyData',
                views: {
                    'tab-person': {
                        templateUrl: 'layout/account/my.modify.data.tpl.html',
                        controller: 'myModifyDataController',
                        controllerAs: 'myModifyData'
                    }
                }
            })

            /**
             * 我的章节
             */
            .state('course', {
                cache: false,
                url: '/my/course',
                templateUrl: 'layout/course/my.course.tpl.html',
                controller: 'myCourseController',
                controllerAs: 'myCourse'
            })


            /**
             * 我的模拟
             */
            .state('test', {
                cache: false,
                url: '/my/test',
                templateUrl: 'layout/course/my.test.tpl.html',
                controller: 'myTestController',
                controllerAs: 'myTest'
            })
            /**
             * 我的复习
             */
            .state('review', {
                cache: false,
                url: '/my/review',
                templateUrl: 'layout/course/my.review.tpl.html',
                controller: 'myReviewController',
                controllerAs: 'myReview'
            })
            /**
             * 我的押题
             */
            .state('spotQuestions', {
                cache: false,
                url: '/my/spotQuestions',
                templateUrl: 'layout/course/my.spot.questions.tpl.html',
                controller: 'mySpotQuestionsController',
                controllerAs: 'mySpotQuestions'
            })

            /**
             * 我的视频里的章节列表
             */
            .state('videoCourseList', {
                cache: false,
                url: '/my/videoCourseList',
                templateUrl: 'layout/course/my.video.course.list.tpl.html',
                controller: 'myVideoCourseListController',
                controllerAs: 'myVideoCourseList'
            })
            /**
             * 我的视频
             */
            .state('video', {
                cache: false,
                url: '/my/video/:CourseID/:ContractID',
                templateUrl: 'layout/course/my.video.tpl.html',
                controller: 'myVideoController',
                controllerAs: 'myVideoList'
            })
            /**
             * 我的视频里下载
             */
            .state('videoDownload', {
                cache: false,
                url: '/my/videoDownload',
                templateUrl: 'layout/course/my.video.download.tpl.html',
                controller: 'myVideoDownloadController',
                controllerAs: 'myVideoDownload'
            })
            /**
             * 视频里下载列表
             */
            .state('downloadList', {
                cache: false,
                url: '/my/downloadList/:CourseID/:ContractID',
                templateUrl: 'layout/course/my.download.list.tpl.html',
                controller: 'myDownloadListController',
                controllerAs: 'myDownloadList'
            })
            /**
             * 我的答疑2017/5/22
             */
            .state('answeringQuestion', {
                cache: false,
                url: '/my/answeringQuestion',
                templateUrl: 'layout/course/my.answering.question.tpl.html',
                controller: 'answeringQuestionController',
                controllerAs: 'answeringQuestion'
            })

            /**
             * 我的合同列表
             */
            .state('contract', {
                cache: false,
                url: '/my/contract/:ContractID/:CourseName',
                templateUrl: 'layout/account/my.contract.tpl.html',
                controller: 'myContractListController',
                controllerAs: 'courseInfoList'
            })
            /**
             * 我的合同
             */
            .state('contractList', {
                cache: false,
                url: '/my/contractList',
                templateUrl: 'layout/account/my.contract.list.tpl.html',
                controller: 'myContractController',
                controllerAs: 'myContract'
            })

            /**
             * 我的合同下的 设置期数
             */
            .state('contractSetting', {
                cache: false,
                url: '/my/contractSetting/:ContractID',
                templateUrl: 'layout/account/my.contract.setting.tpl.html',
                controller: 'myContractSettingController',
                controllerAs: 'contractSetting'
            })

            /**
             * 我的合同下的 合同条款
             */
            .state('contractTerms', {
                cache: false,
                url: '/my/contractTerms/:ContractContentID',
                templateUrl: 'layout/account/my.contract.terms.tpl.html',
                controller: 'myContractTermsController',
                controllerAs: 'contractTerms'
            })

            /**
             * 我的合同下的 申请重学  2017/6/6
             */
            .state('contractRelearning', {
                cache: false,
                url: '/my/contractRelearning/:ExaminationTimeID/:ContractID/:ProductID/:CourseID',
                templateUrl: 'layout/account/my.contract.relearning.tpl.html',
                controller: 'myContractRelearningController',
                controllerAs: 'contractRelearning'
            })
            /**
             * 我的订单
             */
            .state('bill', {
                cache: false,
                url: '/my/bill/:productId/:ids',//加入IP判断多个订单还是单个订单
                templateUrl: 'layout/account/my.bill.tpl.html',
                controller: 'myBillController',
                controllerAs: 'myBill'
            })
            /**
             * 我的订单全部列表
             */
            .state('billList', {
                cache: false,
                url: '/my/billList',
                templateUrl: 'layout/account/my.bill.list.tpl.html',
                controller: 'myBillListController',
                controllerAs: 'myBillList'
            })
            /**
             * 我的订单支付
             */
            .state('billPay', {
                cache: false,
                url: '/my/billPay/:poNo',
                templateUrl: 'layout/account/my.bill.pay.tpl.html',
                controller: 'myBillPayController',
                controllerAs: 'myBillPayItem'
            })

            /**
             * 我的章节下的 每个科目下的章节
             */
            .state('courseList', {
                url: '/my/courseList/:ContractID/:CourseName',
                templateUrl: 'layout/course/my.course.list.tpl.html',
                controller: 'myCourseListController',
                controllerAs: 'myCourseList'
            })
            /**
             *  题板
             */
            .state('testBoard', {
                cache: false,
                url: '/my/testBoard/:ProductID/:ProductName/:SubjectID/:SubjectName/:CourseName/:ChapterID/' +
                ':TpicIndex/:ContractID/:CourseID/:examPaperID/:moduleType/:subType',
                templateUrl: 'layout/course/learningboard.directive.html',
                controller: 'boardController',
                controllerAs: 'vm'
            })




            /**
             * 首页上面按钮
             */
            .state('list', {
                url: '/tab/list/:SubjectID/:SubjectName',
                templateUrl: 'layout/course/tab.list.tpl.html',
                controller: 'homeProductListController',
                controllerAs: 'homeProductList'
            })

            /***
             * 首页上面按钮里的详情页
             */
            .state('listDetail', {
                cache: false,
                url: '/tab/listDetail/:ProductID/:ProductName/:SubjectID/:SubjectName',
                templateUrl: 'layout/course/tab.list.detail.tpl.html',
                controller: 'homeProductInfoController',
                controllerAs: 'homeProductInfo'
            })
            /***
             * 首页下面列表里的详情页
             */
            .state('homeDetail', {
                cache: false,
                url: '/tab/homeDetail/:ProductId/:ProductName',
                templateUrl: 'layout/home/tab.home.detail.tpl.html',
                controller: 'homeDownListController',
                controllerAs: 'homeDownList'

            })


        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/tab/home');

    }
})();
