/**
 * Created by trueideal on 2016/5/13.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("accountService", accountService);

  function accountService($http, $q, _customerType, _ApiUrl) {
    var userInfo = {};
    var userRegisterInfo = {};
    var userInfoSet = {};
    var forgetPwd = {};
    var changePwd = {};
    var userOnline = {};
    var loginCode = 0;
    var service = {
      "fnUserLogin": fnUserLogin,
      "fnFindPassword": fnFindPassword,
      "fnUserRegister": fnUserRegister,
      "FuGetRegisterCode": FuGetRegisterCode,//获取注册验证码
      "FunUserInfoSet": FunUserInfoSet,
      "FunTelFindPassword": FunTelFindPassword,
      "FunTelUpdatePasswordSet": FunTelUpdatePasswordSet,
      "OnlineState": OnlineState,
      "fnSetUser": fnSetUser,
      "fnGetUser": fnGetUser,
      "fnSetCustomerType": fnSetCustomerType,//2016/8/4
      "fnGetCustomerType": fnGetCustomerType//2016/8/4
    };
    return service;

    /**
     * 新版的注册
     * @param username
     * @param password
     * @param Source
     * @param Code
     * @returns {*}
     */
    function fnUserRegister(username, password, Source, Code) {
      loginCode = parseInt(Math.random() * (99999 - 10000 + 1) + 10000);//随机生成一组登录号
      var deferred = $q.defer();
      var postData = {
        "Tel": username,
        "Password": password,
        "Source": Source,
        "loginCode": loginCode,
        "Code": Code
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunUserRegisterSetCode" : _ApiUrl.key + "/FunUserRegisterSetCode";
      $http.post(postUrl, postData).then(function (result) {
        userRegisterInfo = result.data.d;
        deferred.resolve(userRegisterInfo);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 获取注册验证码
     * @param Tel
     * @returns {*}
     * @constructor
     */
    function FuGetRegisterCode(Tel) {
      var deferred = $q.defer();
      var postData = {
        "Tel": Tel
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetRegisterCode" : _ApiUrl.key + "/GetRegisterCode";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }


    /**
     * 登录
     * @param username
     * @param password
     * @returns {*}
     */
    function fnUserLogin(username, password) {
      _customerType = service.fnGetCustomerType().customerType;//将customerType加入到大客户匹配2016/8/4

      if (_customerType == undefined) {
        _customerType = 0;
      }
      loginCode = parseInt(Math.random() * (99999 - 10000 + 1) + 10000);//随机生成一组登录号
      var deferred = $q.defer();
      var postData = {
        "Name": username,
        "Password": password,
        "loginCode": loginCode,
        "unionid": ""
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunUserLoginGet" : _ApiUrl.key + "/FunUserLoginGet";
      $http.post(postUrl, postData).then(function (result) {
        userInfo = result.data.d;
        userInfo.loginCode = loginCode;
        service.fnSetUser(userInfo);
        deferred.resolve(userInfo);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    function fnFindPassword() {

    }

    ///**
    // * 注册
    // * @param username
    // * @param password
    // * @returns {*}
    // */
    //function fnUserRegister(username, password, Source) {
    //  loginCode = parseInt(Math.random() * (99999 - 10000 + 1) + 10000);//随机生成一组登录号
    //  var deferred = $q.defer();
    //  var postData = {
    //    "Tel": username,
    //    "Password": password,
    //    "Source": Source,
    //    "loginCode": loginCode
    //  };
    //  var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunUserRegisterSet" : _ApiUrl.key + "/FunUserRegisterSet";
    //  $http.post(postUrl, postData).then(function (result) {
    //    userRegisterInfo = result.data.d;
    //    deferred.resolve(userRegisterInfo);
    //  }), function (error) {
    //    deferred.reject(error);
    //  }
    //  return deferred.promise;
    //}

    /**
     * 修改信息
     * @param RealName
     * @param IdentityCard
     * @param QQ
     * @param Tel
     * @param Email
     * @param CustomerID
     * @returns {*}
     */
    function FunUserInfoSet(realName, identityCard, qq, tel, email, customerID) {
      var deferred = $q.defer();
      var postData = {
        "RealName": realName,
        "IdentityCard": identityCard,
        "QQ": qq,
        "Tel": tel,
        "Email": email,
        "CustomerID": customerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunUserInfoSet" : _ApiUrl.key + "/FunUserInfoSet";
      $http.post(postUrl, postData).then(function (result) {
        userInfoSet = result.data.d;
        deferred.resolve(userInfoSet);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 找回密码
     * @param Tel
     * @returns {*}
     * @constructor
     */
    function FunTelFindPassword(Tel) {
      var deferred = $q.defer();
      var postData = {
        "Tel": Tel
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunTelFindPassword" : _ApiUrl.key + "/FunTelFindPassword";
      $http.post(postUrl, postData).then(function (result) {
        forgetPwd = result.data.d;
        deferred.resolve(forgetPwd);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     *
     * 修改密码
     * @param Tel
     * @param Code
     * @param Password
     * @returns {*}
     * @constructor
     */
    function FunTelUpdatePasswordSet(Tel, Code, Password) {
      var deferred = $q.defer();
      var postData = {
        "Tel": Tel,
        "Code": Code,
        "Password": Password
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunTelUpdatePasswordSet" : _ApiUrl.key + "/FunTelUpdatePasswordSet";
      $http.post(postUrl, postData).then(function (result) {
        changePwd = result.data.d;
        service.fnSetUser(changePwd);
        deferred.resolve(changePwd);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     *用户是否在线
     * @param loginCode
     * @param CustomerID
     * @returns {*}
     * @constructor
     */
    function OnlineState(loginCode, CustomerID) {
      _customerType = service.fnGetCustomerType().customerType;//将customerType加入到大客户匹配2016/8/4
      var deferred = $q.defer();
      var postData = {
        "loginCode": loginCode,
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/OnlineState" : _ApiUrl.key + "/OnlineState";
      $http.post(postUrl, postData).then(function (result) {
        userOnline = result.data.d;
        deferred.resolve(userOnline);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }


    function fnGetUser() {
      if (!localStorage.user) {
        localStorage.user = JSON.stringify([]);
      }
      return JSON.parse(localStorage.user);
    }

    function fnSetUser(user) {
      localStorage.user = JSON.stringify(user);
    }

    /**
     * 存取customerType值 2016/8/4
     */
    function fnGetCustomerType() {
      if (!localStorage.customerType) {
        localStorage.customerType = JSON.stringify([]);
      }
      return JSON.parse(localStorage.customerType);
    }

    function fnSetCustomerType(customerType) {
      localStorage.customerType = JSON.stringify(customerType);
    }

  }
})()
