/**
 * Created by trueideal on 2016/5/13.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("homeService", homeService);

  function homeService($http, $q, _customerType, _ApiUrl) {
    var HomeProductInfo = {};//产品详细信息
    var HomeProductIsTop = {};//置顶推荐
    var HomeProductList = {};//产品列表
    var HomeSubjectList = {};//课程信息,科目分类
    var version = {};//版本号方法

    var service = {
      "fnHomeProductInfo": fnHomeProductInfo,
      "fnHomeProductIsTop": fnHomeProductIsTop,
      "fnHomeProductList": fnHomeProductList,
      "fnHomeSubjectList": fnHomeSubjectList,
      "fnEditionGet": fnEditionGet,
      "fnGetHome": fnGetHome,
      "fnSetHome": fnSetHome
    };
    return service;

    /**
     * 产品详细信息
     * @returns {*}
     */
    function fnHomeProductInfo(ProductID) {
      var deferred = $q.defer();
      var postData = {
        "ProductID": ProductID,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunProductInfoGet" : _ApiUrl.key + "/FunProductInfoGet";
      $http.post(postUrl, postData).then(function (result) {
        HomeProductInfo = result.data.d;
        service.fnSetHome(HomeProductInfo)
        deferred.resolve(HomeProductInfo);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 置顶推荐
     * @returns {*}
     */
    function fnHomeProductIsTop() {
      var deferred = $q.defer();
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunHomeProductIsTopGet" : _ApiUrl.key + "/FunHomeProductIsTopGet";
      $http.post(postUrl, "").then(function (result) {
        //alert(result.data.d);
        HomeProductIsTop = result.data.d;
        deferred.resolve(HomeProductIsTop);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 产品列表
     * @returns {*}
     */
    function fnHomeProductList(SubjectID) {
      var deferred = $q.defer();
      var postData = {
        "SubjectID": SubjectID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunProductListGet" : _ApiUrl.key + "/FunProductListGet";
      $http.post(postUrl, postData).then(function (result) {
        HomeProductList = result.data.d;
        service.fnSetHome(HomeProductList)
        deferred.resolve(HomeProductList);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     *  课程信息,科目分类
     * @returns {*}
     */
    function fnHomeSubjectList() {
      var deferred = $q.defer();
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunSubjectListGet" : _ApiUrl.key + "/FunSubjectListGet";
      $http.post(postUrl, "").then(function (result) {
        HomeSubjectList = result.data.d;
        service.fnSetHome(HomeSubjectList)
        deferred.resolve(HomeSubjectList);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 获取版本号
     * @returns {*}
     */
    function fnEditionGet() {
      var deferred = $q.defer();
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunEditionGet" : _ApiUrl.key + "/FunEditionGet";
      $http.post(postUrl, "").then(function (result) {
        version = result.data.d;
        deferred.resolve(version);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }


    function fnGetHome() {
      if (!localStorage.home) {
        localStorage.home = JSON.stringify([]);
      }
      return JSON.parse(localStorage.home);
    }

    function fnSetHome(home) {
      localStorage.home = JSON.stringify(home);
    }

  }
})()
