/**
 * Created by trueideal on 2016/5/24.
 */
(function () {
  angular.module("myApp")
    .factory("learingingBoardService", learingingBoardService);

  function learingingBoardService($http, $q, accountService, _customerType, _ApiUrl) {
    var service = {
      "moduleType": "",
      "subType": "",
      "chapterID": "",
      "contractID": "",
      "cIndex": 0,
      "segmentID": "",//2016/9/21 cfa改版
      "tpicEnd": "",//2016/9/21 cfa改版

      "courseID": "",
      "examPaperID": "",
      "questionID": "",
      "isRight": "",
      "choiceID": "",
      "actualTime": 0,
      "learningType": "",
      "myExamPaperID": "",
      "MyExamPaperID": "",//SubjectName暂时替代 MyExamPaperID以避免修改路由2017/5/31
      "myTestPaperID": "",
      "isfirst": "",
      "learningRecordID": "",
      "section": "",
      "isHandle": "",
      "freeTestID": "",
      "evaluationID": "",
      "fnLoadQuestionList": fnLoadQuestionList,
      "fnSaveQuestion": fnSaveQuestion,
      "fnSetLabel": fnSetLabel,
      "fnSetAnsweringQuestionSave": fnSetAnsweringQuestionSave,//插入答疑
      "fnGetAnsweringQuestionList": fnGetAnsweringQuestionList,//获取答疑列表针对题目
      "fnGetMyAnsweringQuestionList": fnGetMyAnsweringQuestionList,//获取我的答疑列表
      "FnContinueLearningQuestionId": FnContinueLearningQuestionId,//章节继续学习
      "FnGetExanmUnfinished": FnGetExanmUnfinished//押题继续学习 2017/5/31
    }
    return service;
    //load Question List
    function fnLoadQuestionList() {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var postData = {};
      var postUrl = "";
      /**
       * 2016/8/6
       */
      switch (service.moduleType) {
        case "trial"://免费试用请求
          postUrl = _ApiUrl.normal;
          break;
        case "evaluation"://免费评测请求
          postUrl = _ApiUrl.normal;
          break;
        default:
          postUrl = _customerType == 0 ? _ApiUrl.normal : _ApiUrl.key;
      }

      switch (service.moduleType) {
        case "chapter"://章节请求
          switch (service.subType) {
            case "normal":
              postData = {
                "CustomerID": accountService.fnGetUser().CustomerID,
                "ChapterID": service.chapterID,
                "ContractID": service.contractID,
                "TpicIndex": service.cIndex,
                "SegmentID": service.segmentID,//2016/9/21 cfa改版
                "TpicEnd": service.tpicEnd//2016/9/21 cfa改版
              };
              postUrl += "/GetChapterList_Change";//此次修改章节方法进行无区分70道题 2017/5/24
              break;
            case "label":
              postData = {
                "CustomerID": accountService.fnGetUser().CustomerID,
                "ChapterID": service.chapterID,
                "ContractID": service.contractID
              };
              postUrl += "/FunChapterLabelList";
              break;
            case "error":
              postData = {
                "CustomerID": accountService.fnGetUser().CustomerID,
                "ChapterID": service.chapterID,
                "ContractID": service.contractID
              };
              postUrl += "/FunChapterErorrList";
              break;
          }
          break;
        case "exam"://押题请求
          switch (service.subType) {
            case "normal":
              postData = {
                "ExamPaperID": service.examPaperID,
                "ContractID": service.contractID,
                "MyExamPaperID": service.MyExamPaperID,
                "CustomerID": accountService.fnGetUser().CustomerID,
              };
              postUrl += "/FunExamTipsInitializ";//押题方法更改 2017/5/31
              break;
            case "label":
              postData = {
                "CustomerID": accountService.fnGetUser().CustomerID,
                "ContractID": service.contractID,
                "ExamPaperID": service.examPaperID
              };
              postUrl = postUrl + "/FunExamTipsLableListGet";
              break;
            case "error":
              postData = {
                "CustomerID": accountService.fnGetUser().CustomerID,
                "ContractID": service.contractID,
                "ExamPaperID": service.examPaperID
              };
              postUrl = postUrl + "/FunExamTipsErorrListGet";
              break;
          }
          break;
        case "test"://模拟请求
          postData = {
            "CustomerID": accountService.fnGetUser().CustomerID,
            "ContractID": service.contractID,
            "CourseID": service.courseID
          };
          postUrl = postUrl + "/FunSimulationGet";
          break;
        case "review"://复习请求
          postData = {
            "CustomerID": accountService.fnGetUser().CustomerID,
            "ContractID": service.contractID,
            "CourseID": service.courseID
          };
          postUrl = postUrl + "/FunReviewGet";
          break;
        case "trial"://免费试用请求
          postData = {
            "CustomerID": accountService.fnGetUser().CustomerID,
            "ChapterID": service.chapterID,
            "CourseID": service.courseID
          };
          postUrl = postUrl + "/FunOnTrialList";
          break;
        case "evaluation"://免费评测请求
          postData = {
            "CustomerID": accountService.fnGetUser().CustomerID,
            "CourseID": service.courseID
          };
          postUrl = postUrl + "/FunEvaluationList";
          break;
      }
      var deferred = $q.defer();
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      };
      return deferred.promise;
    }

    //save Question
    function fnSaveQuestion() {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var postData = {};
      var postUrl = "";
      /**
       * 2016/8/6
       */
      switch (service.moduleType) {
        case "trial"://免费试用请求
          postUrl = _ApiUrl.normal;
          break;
        case "evaluation"://免费评测请求
          postUrl = _ApiUrl.normal;
          break;
        default:
          postUrl = _customerType == 0 ? _ApiUrl.normal : _ApiUrl.key;
      }
      switch (service.moduleType) {
        case "chapter":
          switch (service.subType) {
            case "normal":
              postData = {
                "QuestionID": service.questionID,
                "ChapterID": service.chapterID,
                "IsRight": service.isRight,
                "ChoiceID": service.choiceID,
                "ActualTime": service.actualTime,
                "LearningType": service.learningType,
                "ContractID": service.contractID,
                "CustomerID": accountService.fnGetUser().CustomerID
              };
              postUrl += "/FunChapterLearningRecordSave";
              break;
            case "label":
              postData = {
                "QuestionID": service.questionID,
                "ChapterID": service.chapterID,
                "IsRight": service.isRight,
                "ChoiceID": service.choiceID,
                "ActualTime": service.actualTime,
                "LearningType": service.learningType,
                "ContractID": service.contractID,
                "CustomerID": accountService.fnGetUser().CustomerID
              };
              postUrl += "/FunChapterLabelLearningRecordSave";
              break;
            case "error":
              postData = {
                "QuestionID": service.questionID,
                "ChapterID": service.chapterID,
                "IsRight": service.isRight,
                "ChoiceID": service.choiceID,
                "ActualTime": service.actualTime,
                "LearningType": service.learningType,
                "ContractID": service.contractID,
                "CustomerID": accountService.fnGetUser().CustomerID
              };
              postUrl += "/FunChapterErorrRecordSave";
              break;
          }
          break;
        case "exam":
          switch (service.subType) {
            case "normal":
              postData = {
                "ChapterID": service.chapterID,
                "QuestionID": service.questionID,
                "IsRight": service.isRight,
                "ChoiceID": service.choiceID,
                "ActualTime": service.actualTime,
                "LearningType": service.learningType,
                "MyExamPaperID": service.myExamPaperID,
                "isHandle": service.isHandle,
                "ContractID": service.contractID,
                "ExamPaperID": service.examPaperID,
                "CustomerID": accountService.fnGetUser().CustomerID
              };
              postUrl = postUrl + "/FunExamTipsRecordSaveSet";
              break;
            case "label":
              postData = {
                "ChapterID": service.chapterID,
                "QuestionID": service.questionID,
                "IsRight": service.isRight,
                "ChoiceID": service.choiceID,
                "ActualTime": service.actualTime,
                "ContractID": service.contractID,
                "ExamPaperID": service.examPaperID,
                "CustomerID": accountService.fnGetUser().CustomerID
              };
              postUrl = postUrl + "/FunExamTipsLableSaveLearningRecordSet";
              break;
            case "error":
              postData = {
                "ChapterID": service.chapterID,
                "QuestionID": service.questionID,
                "IsRight": service.isRight,
                "ChoiceID": service.choiceID,
                "ActualTime": service.actualTime,
                "ContractID": service.contractID,
                "ExamPaperID": service.examPaperID,
                "CustomerID": accountService.fnGetUser().CustomerID
              };
              postUrl = postUrl + "/FunExamTipsErorrSaveLearningSet";
              break;
          }
          break;
        case "test":
          postData = {
            "ChapterID": service.chapterID,
            "QuestionID": service.questionID,
            "IsRight": service.isRight,
            "ChoiceID": service.choiceID,
            "ActualTime": service.actualTime,
            "LearningType": service.learningType,
            "MyTestPaperID": service.myTestPaperID,
            "isHandle": service.isHandle,
            "ContractID": service.contractID,
            "CustomerID": accountService.fnGetUser().CustomerID
          };
          postUrl = postUrl + "/FunSaveLearningRecordSet";
          break;
        case "review":
          postData = {
            "LearningRecordID": service.learningRecordID,
            "IsRight": service.isRight,
            "ChoiceID": service.choiceID,
            "ActualTime": service.actualTime,
            "Section": service.section,
            "LearningType": service.learningType,
            "ContractID": service.contractID,
            "CustomerID": accountService.fnGetUser().CustomerID
          };
          postUrl = postUrl + "/FunReviewSaveLearningRecordSet";
          break;
        case "trial":
          postData = {
            "LearningRecordID": service.learningRecordID,
            "IsRight": service.isRight,
            "ChoiceID": service.choiceID,
            "ActualTime": service.actualTime,
            "Section": service.section,
            "FreeTestID": service.freeTestID,
            "CustomerID": accountService.fnGetUser().CustomerID
          };
          postUrl = postUrl + "/FunOnTrialSave";
          break;
        case "evaluation":
          postData = {
            "LearningRecordID": service.learningRecordID,
            "IsRight": service.isRight,
            "ChoiceID": service.choiceID,
            "ActualTime": service.actualTime,
            "Section": service.section,
            "EvaluationID": service.evaluationID,
            "CustomerID": accountService.fnGetUser().CustomerID
          };
          postUrl = postUrl + "/FunEvaluationSave";
          break;
      }
      var deferred = $q.defer();
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    //get chapter question count
    function fnGetChapterCount() {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var postData = {};
      var postUrl = _customerType == 0 ? _ApiUrl.normal : _ApiUrl.key;
      postUrl += "/Get_AppChapterTopicNum";
      postData = {
        "CustomerID": accountService.fnGetUser().CustomerID,
        "ChapterID": service.chapterID,
        "ContractID": service.contractID,
        "Courseid": service.courseID,
      };
      var deferred = $q.defer();
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    //fnSetLabel
    function fnSetLabel() {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var postData = {};
      var postUrl = "";
      /**
       * 2016/8/6
       */
      switch (service.moduleType) {
        case "trial"://免费试用请求
          postUrl = _ApiUrl.normal;
          break;
        case "evaluation"://免费评测请求
          postUrl = _ApiUrl.normal;
          break;
        default:
          postUrl = _customerType == 0 ? _ApiUrl.normal : _ApiUrl.key;
      }
      switch (service.moduleType) {
        case "chapter":
          switch (service.subType) {
            case "normal":
              postUrl += "/FunChapterIsLabelSave";
              break;
            case "label":
              postUrl += "/FunChapterLabelSave";
              break;
            case "error":
              postUrl += "/FunChapterLabelErorrSave";
              break;
          }
          break;
        case "exam":
          postUrl += "/FunExamTipsIsLabel_SaveSet";
          break;
        case "test":
          postUrl += "/FunIsLabel_SaveSet";
          break;
        case "review":
          postUrl += "/FunReviewSaveIsLabelSet";
          break;
        case "trial":
          postUrl += "/FunEvaluationIsLabel_Save";
          break;
        case "evaluation":
          postUrl += "/FunOnTrialIsLabelSave";
          break;
      }
      if (service.moduleType == "exam") {
        postData = {
          "QuestionID": service.questionID,
          "CustomerID": accountService.fnGetUser().CustomerID,
          "ExamPaperID": service.examPaperID
        };
      } else {
        postData = {
          "CustomerID": accountService.fnGetUser().CustomerID,
          "QuestionID": service.questionID
        };
      }
      var deferred = $q.defer();
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 插入答疑2017/5/22
     * @param QuestionID
     * @param Question
     * @returns {*}
     */
    function fnSetAnsweringQuestionSave(QuestionID, Question) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "QuestionID": QuestionID,
        "Question": Question,
        "CustomerID": accountService.fnGetUser().CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/SetAnsweringQuestionSave" : _ApiUrl.key + "/SetAnsweringQuestionSave";
      $http.post(postUrl, postData).then(function (result) {
        var SetAnswering = result.data.d;
        deferred.resolve(SetAnswering);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 获取答疑列表针对题目2017/5/22
     * @param QuestionID
     * @returns {*}
     */
    function fnGetAnsweringQuestionList(QuestionID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "QuestionID": QuestionID,
        "CustomerID": accountService.fnGetUser().CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetAnsweringQuestionList" : _ApiUrl.key + "/GetAnsweringQuestionList";
      $http.post(postUrl, postData).then(function (result) {
        var GetAnsweringQuestion = result.data.d;
        deferred.resolve(GetAnsweringQuestion);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 获取我的答疑列表2017/5/22
     * @param PageSize
     * @param CurrentPage
     * @returns {*}
     */
    function fnGetMyAnsweringQuestionList(PageSize, CurrentPage) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "PageSize": PageSize,
        "CurrentPage": CurrentPage,
        "CustomerID": accountService.fnGetUser().CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetMyAnsweringQuestionList" : _ApiUrl.key + "/GetMyAnsweringQuestionList";
      $http.post(postUrl, postData).then(function (result) {
        var GetMyAnsweringQuestion = result.data.d;
        deferred.resolve(GetMyAnsweringQuestion);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 章节继续学习的题目id
     * @param ChapterID
     * @returns {*}
     */
    function FnContinueLearningQuestionId(ChapterID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "ChapterID": ChapterID,
        "CustomerID": accountService.fnGetUser().CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/ContinueLearningQuestionId" : _ApiUrl.key + "/ContinueLearningQuestionId";
      $http.post(postUrl, postData).then(function (result) {
        var ContinueLearning = result.data.d;
        deferred.resolve(ContinueLearning);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }

    /**
     * 押题继续学习ID 2017/5/31
     * @param ExamPaperID
     * @returns {*}
     * @constructor
     */
    function FnGetExanmUnfinished(ExamPaperID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "ExamPaperID": ExamPaperID,
        "CustomerID": accountService.fnGetUser().CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetExanmUnfinished" : _ApiUrl.key + "/GetExanmUnfinished";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;
    }


  }
})();
