/**
 * Created by david-pc on 2017/11/6.
 * 直播服务
 */
(function () {
    'use strict';
    angular.module("myApp")
        .factory("liveBroadcastService", liveBroadcastService);

    function liveBroadcastService(accountService, $http, $q, _customerType, _ApiUrl) {
        //声明方法
        var service = {
            "funLiveView": funLiveView,
            "funGetLiveInfo": funGetLiveInfo,
            "funLiveFreePay": funLiveFreePay,
            "funGetLiveUrl": funGetLiveUrl,
            "funPerson_LiveList": funPerson_LiveList,
            "funLiveBanner": funLiveBanner
        };
        return service;
        /**
         * 顶部直播图片
         * @returns {*}
         */
        function funLiveBanner() {
            var deferred = $q.defer();
            var postUrl = _customerType == 0 ? _ApiUrl.normal + "/LiveBanner" : _ApiUrl.key + "/LiveBanner";
            $http.post(postUrl, "").then(function (result) {
                deferred.resolve(result.data.d);
            }), function (error) {
                deferred.reject(error);
            };
            return deferred.promise;//回调
        }

        /**
         * 列表方法
         * @param SearchType
         * @param TempMonth
         * @param subjectid
         * @param StartDate
         * @param EndDate
         * @returns {*}
         */
        function funLiveView(SearchType, TempMonth, subjectid, StartDate, EndDate) {
            var deferred = $q.defer();
            var postData = {
                "CustomerID": accountService.fnGetUser().CustomerID == undefined ? "" : accountService.fnGetUser().CustomerID,
                "SearchType": SearchType,
                "TempMonth": TempMonth,
                "subjectid": subjectid,
                "StartDate": StartDate,
                "EndDate": EndDate
            };
            var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetLiveList" : _ApiUrl.key + "/GetLiveList";
            $http.post(postUrl, postData).then(function (result) {
                deferred.resolve(result.data.d);
            }), function (error) {
                deferred.reject(error);
            };
            return deferred.promise;//回调
        }

        /**
         *直播信息详情
         * @param ID
         * @returns {*}
         */
        function funGetLiveInfo(ID) {
            var deferred = $q.defer();
            var postData = {
                "ID": ID,
                "CustomerID": accountService.fnGetUser().CustomerID == undefined ? "" : accountService.fnGetUser().CustomerID
            };
            var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetLiveInfo" : _ApiUrl.key + "/GetLiveInfo";
            $http.post(postUrl, postData).then(function (result) {
                deferred.resolve(result.data.d);
            }), function (error) {
                deferred.reject(error);
            };
            return deferred.promise;//回调
        }

        /**
         * 报名方法
         * @param ProductID
         * @returns {*}
         */
        function funLiveFreePay(ProductID) {
            var deferred = $q.defer();
            var postData = {
                "ProductID": ProductID,
                "CustomerID": accountService.fnGetUser().CustomerID == undefined ? "" : accountService.fnGetUser().CustomerID
            };
            var postUrl = _customerType == 0 ? _ApiUrl.normal + "/LiveFreePay" : _ApiUrl.key + "/LiveFreePay";
            $http.post(postUrl, postData).then(function (result) {
                deferred.resolve(result.data.d);
            }), function (error) {
                deferred.reject(error);
            };
            return deferred.promise;//回调
        }

        /**
         * 获取直播链接
         * @param ProductID
         * @returns {*}
         */
        function funGetLiveUrl(ProductID) {
            var deferred = $q.defer();
            var postData = {
                "ProductID": ProductID,
                "CustomerID": accountService.fnGetUser().CustomerID == undefined ? "" : accountService.fnGetUser().CustomerID
            };
            var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetLiveUrl" : _ApiUrl.key + "/GetLiveUrl";
            $http.post(postUrl, postData).then(function (result) {
                deferred.resolve(result.data.d);
            }), function (error) {
                deferred.reject(error);
            };
            return deferred.promise;//回调
        }

        /**
         * CustomerID用户id
         SubjectID科目id 不是空是条件
         isFree是否免费 0是免费1是付费
         isLive 0 未开始 1正在直播2是已结束
         "StartDate"开始时间
         "EndDate"结束时间
         "Key"关键字 不加此条件空着
         "CurrentPage"第几页
         "PageSize"每页显示多少条
         "isLoad"0是第一次加载
         * @param SubjectID
         * @param isFree
         * @param isLive
         * @param isLoad
         * @returns {*}
         */
        function funPerson_LiveList(SubjectID, isFree, isLive, isLoad) {
            var deferred = $q.defer();
            var postData = {
                "CustomerID": accountService.fnGetUser().CustomerID == undefined ? "" : accountService.fnGetUser().CustomerID,
                "SubjectID": "",//给“” 没有搜索
                "isFree": isFree,
                "isLive": isLive,
                "StartDate": "",
                "EndDate": "",
                "Key": "",
                "isLoad": isLoad
            };
            var postUrl = _customerType == 0 ? _ApiUrl.normal + "/Person_LiveList" : _ApiUrl.key + "/Person_LiveList";
            $http.post(postUrl, postData).then(function (result) {
                deferred.resolve(result.data.d);
            }), function (error) {
                deferred.reject(error);
            };
            return deferred.promise;//回调
        }

    }
})();

