/**
 * Created by trueideal on 2016/6/4.
 */
(function () {
  angular.module("myApp")
    .factory("myBillPayService", myBillPayService);

  function myBillPayService($http, $q, _customerType, _ApiUrl) {
    var service = {
      "fnPay": fnPay,
      "fnLoadPayItemInfo": fnLoadPayItemInfo,
      "fnCPOPayStateGet": fnCPOPayStateGet,
      "FunPOPayReturn": FunPOPayReturn
    };
    return service;
    /**
     * 支付宝支付方法
     * @param PaymentMethod
     * @param PoNo
     * @returns {*}
     */
    function fnPay(PaymentMethod, PoNo) {
      var deferred = $q.defer();
      var postData = {
        "PaymentMethod": PaymentMethod,
        "PONO": PoNo
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunPay" : _ApiUrl.key + "/FunPay";
      $http.post(postUrl, postData).then(function (result) {
        return deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      };
      return deferred.promise;//回调
    }

    /**
     * 订单详情所有items订单总价
     * @param PoNo
     * @returns {*}
     */
    function fnLoadPayItemInfo(PoNo) {
      var deferred = $q.defer();
      var postData = {
        "PONo": PoNo
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunPOItemsSumPrice" : _ApiUrl.key + "/FunPOItemsSumPrice";
      $http.post(postUrl, postData).then(function (result) {
        return deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 支付状态
     * @param PoNo
     * @returns {*}
     */
    function fnCPOPayStateGet(PoNo) {
      var deferred = $q.defer();
      var postData = {
        "PONo": PoNo
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunCPOPayStateGet" : _ApiUrl.key + "/FunCPOPayStateGet";
      $http.post(postUrl, postData).then(function (result) {
        return deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /***
     *生成合同
     * @param PoNo
     * @param PayTotalAmount
     * @returns {*}
     * @constructor
     */
    function FunPOPayReturn(PoNo, PaymentMethod) {
      var deferred = $q.defer();
      var postData = {
        "PONo": PoNo,
        "PaymentMethod": PaymentMethod
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunPOPayReturn" : _ApiUrl.key + "/FunPOPayReturn";
      $http.post(postUrl, postData).then(function (result) {
        return deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }


  }
})()
