/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("myBillService", myBillService);

  function myBillService($http, $q, _customerType, _ApiUrl) {
    var billInfo = {};
    var billListInfo = {};
    var billExit = {};
    var billShopCart = {};
    //声明方法
    var service = {
      "fnCreatePOSetGetItems_List": fnCreatePOSetGetItems_List,
      "FunPO_ListGet": FunPO_ListGet,
      "funPO_Del": funPO_Del,
      "CarToPO": CarToPO,
      "fnSetBill": fnSetBill,
      "fnGetBill": fnGetBill
    };
    return service;
    /**
     * 获取产品订单方法
     * @param customerID
     * @param productID
     * @returns {*}
     */
    function fnCreatePOSetGetItems_List(customerID, productID) {
      var deferred = $q.defer();
      var postData = {
        "CustomerID": customerID,
        "ProductID": productID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunCeratePOSetGetItems_List" : _ApiUrl.key + "/FunCeratePOSetGetItems_List";
      $http.post(postUrl, postData).then(function (result) {
        billInfo = result.data.d;
        service.fnSetBill(billInfo)
        deferred.resolve(billInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 请求生成订单（订单productID多个，购物车请求）
     * @param customerID
     * @param productID
     * @returns {*}
     * @constructor
     */
    function CarToPO(customerID, productID) {
      var deferred = $q.defer();
      var postData = {
        "CustomerID": customerID,
        "ProductIDs": productID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/CarToPO" : _ApiUrl.key + "/CarToPO";
      $http.post(postUrl, postData).then(function (result) {
        billShopCart = result.data.d;
        deferred.resolve(billShopCart);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }


    /**
     * 订单列表
     * @param customerID
     * @returns {*}
     * @constructor
     */
    function FunPO_ListGet(CustomerID, PageSize, CurrentPage) {
      var deferred = $q.defer();
      var postData = {
        "CustomerID": CustomerID,
        "PageSize": PageSize,
        "CurrentPage": CurrentPage
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunPO_ListGet" : _ApiUrl.key + "/FunPO_ListGet";
      $http.post(postUrl, postData).then(function (result) {
        billListInfo = result.data.d;
        service.fnSetBill(billListInfo)
        deferred.resolve(billListInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     *删除订单
     * @param POID订单id
     * @returns {*}
     */
    function funPO_Del(POID) {
      var deferred = $q.defer();
      var postData = {
        "POID": POID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/funPO_Del" : _ApiUrl.key + "/funPO_Del";
      $http.post(postUrl, postData).then(function (result) {
        billExit = result.data.d;
        service.fnSetBill(billExit)
        deferred.resolve(billExit);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    function fnGetBill() {
      if (!localStorage.bill) {
        localStorage.bill = JSON.stringify([]);
      }
      return JSON.parse(localStorage.bill);
    }

    function fnSetBill(bill) {
      localStorage.bill = JSON.stringify(bill);
    }
  }
})()

