/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("myContractService", myContractService);

  function myContractService(accountService,$http, $q, _customerType, _ApiUrl) {
    var contractListInfo = {};
    var contractInfo = {};
    var ExaminationTimeInfo = {};
    var ExaminationTimeSaveInfo = {};
    var ContractContentInfo = {};
    //声明方法
    var service = {
      "FunContractListGet": FunContractListGet,
      "FunContractInfotGet": FunContractInfotGet,
      "FunExaminationTimeListGet": FunExaminationTimeListGet,
      "FunExaminationTimeSaveSet": FunExaminationTimeSaveSet,
      "FunContractContentGet": FunContractContentGet,
      "FunSetOverTimeSave": FunSetOverTimeSave,//自动加时 2017/6/6
      "FunGetRLearnExaminationList": FunGetRLearnExaminationList,//重学期数列表2017/6/6
      "FunSetRLearnSave": FunSetRLearnSave,//保存重学申请 2017/6/6
      "fnSetContract": fnSetContract,
      "fnGetContract": fnGetContract
    };
    return service;
    /**
     * 获取我的合同列表
     * @param CustomerID
     * @returns {*}
     */
    function FunContractListGet(CustomerID) {
      var deferred = $q.defer();
      var postData = {
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunContractListGet" : _ApiUrl.key + "/FunContractListGet";
      $http.post(postUrl, postData).then(function (result) {
        contractListInfo = result.data.d;
        service.fnSetContract(contractListInfo)
        deferred.resolve(contractListInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 获取合同详细信息
     * @param ContractID
     * @returns {*}
     * @constructor
     */
    function FunContractInfotGet(ContractID) {
      var deferred = $q.defer();
      var postData = {
        "ContractID": ContractID,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunContracInrotGet" : _ApiUrl.key + "/FunContracInrotGet";
      $http.post(postUrl, postData).then(function (result) {
        contractInfo = result.data.d;
        service.fnSetContract(contractInfo)
        deferred.resolve(contractInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 期数列表
     * @param ContractID
     * @returns {*}
     * @constructor
     */
    function FunExaminationTimeListGet(ContractID) {
      var deferred = $q.defer();
      var postData = {
        "ContractID": ContractID,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunExaminationTimeListGet" : _ApiUrl.key + "/FunExaminationTimeListGet";
      $http.post(postUrl, postData).then(function (result) {
        ExaminationTimeInfo = result.data.d;
        service.fnSetContract(ExaminationTimeInfo)
        deferred.resolve(ExaminationTimeInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 保存期数
     * @param ContractID
     * @param ExaminationTimeID
     * @returns {*}
     * @constructor
     */
    function FunExaminationTimeSaveSet(ContractID, ExaminationTimeID) {
      var deferred = $q.defer();
      var postData = {
        "ContractID": ContractID,
        "ExaminationTimeID": ExaminationTimeID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunExaminationTimeSaveSet" : _ApiUrl.key + "/FunExaminationTimeSaveSet";
      $http.post(postUrl, postData).then(function (result) {
        ExaminationTimeSaveInfo = result.data.d;
        service.fnSetContract(ExaminationTimeSaveInfo)
        deferred.resolve(ExaminationTimeSaveInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     *合同条款方法
     * @param ContractContentID
     * @returns {*}
     * @constructor
     */
    function FunContractContentGet(ContractContentID) {
      var deferred = $q.defer();
      var postData = {
        "ContractID": ContractContentID//这里的ContractContentID参数替换为ContractID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunContractContentGet" : _ApiUrl.key + "/FunContractContentGet";
      $http.post(postUrl, postData).then(function (result) {
        ContractContentInfo = result.data.d;
        service.fnSetContract(ContractContentInfo)
        deferred.resolve(ContractContentInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     *  自动加时 2017/6/6
     * @param ContractID
     * @returns {*}
     * @constructor
     */
    function FunSetOverTimeSave(ContractID) {
      var deferred = $q.defer();
      var postData = {
        "ContractID": ContractID,
        "CustomerID": accountService.fnGetUser().CustomerID //2017/10/25  加个  CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/SetOverTimeSave" : _ApiUrl.key + "/SetOverTimeSave";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 重学期数列表
     * @param ProductID
     * @param CourseID
     * @returns {*}
     * @constructor
     */
    function FunGetRLearnExaminationList(ProductID, CourseID) {
      var deferred = $q.defer();
      var postData = {
        "ProductID": ProductID,
        "CourseID": CourseID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetRLearnExaminationList" : _ApiUrl.key + "/GetRLearnExaminationList";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     *  保存重学申请
     * @param InstituteLoginName 协会账号
     * @param InstituteLoginPassword 协会密码
     * @param Reason 原因
     * @param Remark 备注
     * @param ContractID 合同id
     * @param ExaminationTimeID 期数id
     * @param CustomerID 用户id
     * @returns {*}
     * @constructor
     */
    function FunSetRLearnSave(InstituteLoginName, InstituteLoginPassword, Reason, Remark, ContractID, ExaminationTimeID, CustomerID) {
      var deferred = $q.defer();
      var postData = {
        "InstituteLoginName": InstituteLoginName,
        "InstituteLoginPassword": InstituteLoginPassword,
        "Reason": Reason,
        "Remark": Remark,
        "ContractID": ContractID,
        "ExaminationTimeID": ExaminationTimeID,
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/SetRLearnSave" : _ApiUrl.key + "/SetRLearnSave";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }


    function fnGetContract() {
      if (!localStorage.Contract) {
        localStorage.Contract = JSON.stringify([]);
      }
      return JSON.parse(localStorage.Contract);
    }

    function fnSetContract(Contract) {
      localStorage.Contract = JSON.stringify(Contract);
    }
  }
})()

