/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("myCourseService", myCourseService);

  function myCourseService($http, $q, _customerType, _ApiUrl, accountService) {
    var subjectInfo = {};
    var courseInfo = {};
    //声明方法
    var service = {
      "FunCourseListGet": FunCourseListGet,
      "FunChapterListGet": FunChapterListGet,
      "fnSetCourse": fnSetCourse,
      "fnGetCourse": fnGetCourse
    };
    return service;
    /**
     * 获取我的章节中课程列表
     * @param CustomerID
     * @returns {*}
     */
    function FunCourseListGet(CustomerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunCourseListGet" : _ApiUrl.key + "/FunCourseListGet";
      $http.post(postUrl, postData).then(function (result) {
        subjectInfo = result.data.d;
        service.fnSetCourse(subjectInfo)
        deferred.resolve(subjectInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 获取我的章节下的章节列表
     * @param ContractID
     * @returns {*}
     * @constructor
     */
    function FunChapterListGet(ContractID,CustomerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();

      if(_customerType==1){
        var postData = {
          "ContractID": ContractID,
          "CustomerID": CustomerID
        };
      }else {
        var postData = {
          "ContractID": ContractID
        };
      }

      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunChapterListGet" : _ApiUrl.key + "/FunChapterListGet";
      $http.post(postUrl, postData).then(function (result) {
        courseInfo = result.data.d;
        service.fnSetCourse(courseInfo)
        deferred.resolve(courseInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    function fnGetCourse() {
      if (!localStorage.Course) {
        localStorage.Course = JSON.stringify([]);
      }
      return JSON.parse(localStorage.Course);
    }

    function fnSetCourse(Course) {
      localStorage.Course = JSON.stringify(Course);
    }
  }
})()

