/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("mySpotQuestionsService", mySpotQuestionsService);

  function mySpotQuestionsService($http, $q, _customerType, _ApiUrl, accountService) {
    var spotQuestionsSubjectInfo = {};
    var spotQuestionsCourseInfo = {};
    //声明方法
    var service = {
      "FunExamListGet": FunExamListGet,
      "FunExamPaperContent": FunExamPaperContent,//押题列表里的具体押题 2017/6/19
      "fnSetSpotQuestions": fnSetSpotQuestions,
      "fnGetSpotQuestions": fnGetSpotQuestions
    };
    return service;
    /**
     * 获取我的押题课程列表
     * @param CustomerID
     * @returns {*}
     */
    function FunExamListGet(CustomerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunExamTipsListGet" : _ApiUrl.key + "/FunExamTipsListGet";
      $http.post(postUrl, postData).then(function (result) {
        spotQuestionsSubjectInfo = result.data.d;
        service.fnSetSpotQuestions(spotQuestionsSubjectInfo)
        deferred.resolve(spotQuestionsSubjectInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     *押题列表里的具体押题 2017/6/19
     * @param CourseID
     * @param ExaminationTimeID
     * @returns {*}
     * @constructor
     */
    function FunExamPaperContent(CourseID, ExaminationTimeID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CourseID": CourseID,
        "ExaminationTimeID": ExaminationTimeID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/ExamPaperContent" : _ApiUrl.key + "/ExamPaperContent";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    function fnGetSpotQuestions() {
      if (!localStorage.SpotQuestions) {
        localStorage.SpotQuestions = JSON.stringify([]);
      }
      return JSON.parse(localStorage.SpotQuestions);
    }

    function fnSetSpotQuestions(SpotQuestions) {
      localStorage.SpotQuestions = JSON.stringify(SpotQuestions);
    }
  }
})()

