/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("myVideoService", myVideoService);

  function myVideoService($cordovaToast, $timeout, $cordovaFileTransfer, $http, $q, _customerType, _ApiUrl, accountService) {
    var videoListInfo = {};
    var videoInfo = {};
    var videoTime = {};
    //声明方法
    var service = {
      "FunVideoDownload": FunVideoDownload,
      "FunVideoListGet": FunVideoListGet,
      "FunPlayerListGet": FunPlayerListGet,
      "FunVideoSaveSet": FunVideoSaveSet,
      "GetVideoUrl": GetVideoUrl,//2017/8/31
      "fnSetVideo": fnSetVideo,
      "fnGetVideo": fnGetVideo
    };
    return service;

    function FunVideoDownload(url, segment, downloadIndex, list) {
      var deferred = $q.defer();
      var targetPath = "file:///storage/sdcard0/Download" + "/" + segment + ".mp4"; //APP下载存放的路径，可以使用cordova file插件进行相关配置
      var trustHosts = true
      var options = {};
      $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
        return deferred.promise;//成功回调
        $cordovaToast.showShortBottom('下载成功！');
      }, function (err) {
        $cordovaToast.showShortBottom('下载失败！');
        list[downloadIndex].ProgressItem = 0;
      }, function (progress) {
        //进度，这里使用文字显示下载百分比
        $timeout(function () {
          var downloadProgress = (progress.loaded / progress.total) * 100;
          list[downloadIndex].ProgressItem = Math.floor(downloadProgress);
          if (downloadProgress > 99) {
            downloadProgress = 100;
          }
          deferred.resolve(list);
        })
      });

    }


    /**
     * 获取我的视频列表
     * @param customerID
     * @returns {*}
     * @constructor
     */
    function FunVideoListGet(customerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CustomerID": customerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunVideoListGet" : _ApiUrl.key + "/FunVideoListGet";
      $http.post(postUrl, postData).then(function (result) {
        videoListInfo = result.data.d;
        deferred.resolve(videoListInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 获取视频播放列表
     * @param CourseID
     * @returns {*}
     * @constructor
     */
    function FunPlayerListGet(CourseID, ContractID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CourseID": CourseID,
        "ContractID": ContractID  //加合同判断  2017/8/9
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunPlayerListGet1" : _ApiUrl.key + "/FunPlayerListGet1";
      $http.post(postUrl, postData).then(function (result) {
        videoInfo = result.data.d;
        deferred.resolve(videoInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 上传视频播放时间
     * @param LearningID 视频记录id
     * @param VideoID 视频id
     * @param ContractID 合同id
     * @param ActualTime  时间秒
     * @param CustomerID 客户id
     * @returns {*}
     * @constructor
     */
    function FunVideoSaveSet(LearningID, VideoID, ContractID, ActualTime, CustomerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "LearningID": LearningID,
        "VideoID": VideoID,
        "ContractID": ContractID,
        "ActualTime": ActualTime,
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunVideoSaveSet" : _ApiUrl.key + "/FunVideoSaveSet";
      $http.post(postUrl, postData).then(function (result) {
        videoTime = result.data.d;
        deferred.resolve(videoTime);
      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 单独取视频地址   2017/8/31
     * @param CourseID
     * @param ContractID
     * @param VideoID
     * @returns {*}
     * @constructor
     */
    function GetVideoUrl(CourseID, ContractID, VideoID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CourseID": CourseID,
        "ContractID": ContractID,
        "VideoID": VideoID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/GetVideoUrl" : _ApiUrl.key + "/GetVideoUrl";
      $http.post(postUrl, postData).then(function (result) {
        deferred.resolve(result.data.d);
      }), function (error) {
        deferred.reject(error);
      };
      return deferred.promise;//回调
    }


    function fnGetVideo() {
      if (!localStorage.Video) {
        localStorage.Video = JSON.stringify([]);
      }
      return JSON.parse(localStorage.Video);
    }

    function fnSetVideo(Video) {
      localStorage.Video = JSON.stringify(Video);
    }
  }
})()

