/**
 * Created by zjw-pc on 2016/5/23.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("wikipediaService", wikipediaService);

  function wikipediaService($http, $q, _customerType, _ApiUrl) {
    var wikipediaInfo = {};
    var wikipediaNews = {};
    var questions = {};
    //声明方法
    var service = {
      "FunJournalismList": FunJournalismList,
      "FunJournalismClientGet": FunJournalismClientGet,
      "FunProblemList": FunProblemList,
      "fnSetwikipedia": fnSetwikipedia,
      "fnGetwikipedia": fnGetwikipedia
    };
    return service;
    /**
     * 请求新闻列表
     * @param CurrentPage 页码
     * @param PageSize   载入条数
     * @returns {*}
     * @constructor
     */
    function FunJournalismList(CurrentPage, PageSize) {
      var deferred = $q.defer();
      var postData = {
        "CurrentPage": CurrentPage,
        "PageSize": PageSize,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunJournalismListGet" : _ApiUrl.key + "/FunJournalismListGet";
      $http.post(postUrl, postData).then(function (result) {
        wikipediaInfo = result.data.d;
        service.fnSetwikipedia(wikipediaInfo)
        deferred.resolve(wikipediaInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 请求新闻详细页
     * @param NewID
     * @returns {*}
     * @constructor
     */
    function FunJournalismClientGet(NewID) {
      var deferred = $q.defer();
      var postData = {
        "NewID": NewID,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunJournalismClientGet" : _ApiUrl.key + "/FunJournalismClientGet";
      $http.post(postUrl, postData).then(function (result) {
        wikipediaNews = result.data.d;
        service.fnSetwikipedia(wikipediaNews)
        deferred.resolve(wikipediaNews);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * 常见问题
     * @param CurrentPage
     * @param PageSize
     * @returns {*}
     * @constructor
     */

    function FunProblemList(CurrentPage, PageSize) {
      var deferred = $q.defer();
      var postData = {
        "CurrentPage": CurrentPage,
        "PageSize": PageSize,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunProblemListGet" : _ApiUrl.key + "/FunProblemListGet";
      $http.post(postUrl, postData).then(function (result) {
        questions = result.data.d;
        service.fnSetwikipedia(questions)
        deferred.resolve(questions);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }

    /**
     * get set 方法
     */
    function fnGetwikipedia() {
      if (!localStorage.wikipedia) {
        localStorage.wikipedia = JSON.stringify([]);
      }
      return JSON.parse(localStorage.wikipedia);
    }

    function fnSetwikipedia(wikipedia) {
      localStorage.wikipedia = JSON.stringify(wikipedia);
    }
  }
})()

